namespace com.progsbase.no.inductive.libraries.Matrices_v0_2_13{

using static System.Math;

public class Matrix{
	public MatrixRow [] r;
}
public class MatrixArrayReference{
	public Matrix [] matrices;
}
public class MatrixReference{
	public Matrix matrix;
}
public class MatrixRow{
	public double [] c;
}
public class ComplexMatrix{
	public ComplexMatrixRow [] r;
}
public class ComplexMatrixArrayReference{
	public ComplexMatrix [] matrices;
}
public class ComplexMatrixReference{
	public ComplexMatrix matrix;
}
public class ComplexMatrixRow{
	public cComplexNumber [] c;
}
public class BooleanArrayReference{
	public bool [] booleanArray;
}
public class BooleanReference{
	public bool booleanValue;
}
public class CharacterReference{
	public char characterValue;
}
public class NumberArrayReference{
	public double [] numberArray;
}
public class NumberReference{
	public double numberValue;
}
public class StringArrayReference{
	public StringReference [] stringArray;
}
public class StringReference{
	public char [] stringx;
}
public class cComplexNumber{
	public double re;
	public double im;
}
public class cComplexNumberArrayReference{
	public cComplexNumber [] complexNumbers;
}
public class cComplexNumberReference{
	public cComplexNumber complexNumbers;
}
public class cPolarComplexNumber{
	public double r;
	public double phi;
}
public class pComplexPolynomial{
	public cComplexNumber [] cs;
}
public class LinkedListNodeStrings{
	public bool end;
	public char [] value;
	public LinkedListNodeStrings next;
}
public class LinkedListStrings{
	public LinkedListNodeStrings first;
	public LinkedListNodeStrings last;
}
public class LinkedListNodeNumbers{
	public LinkedListNodeNumbers next;
	public bool end;
	public double value;
}
public class LinkedListNumbers{
	public LinkedListNodeNumbers first;
	public LinkedListNodeNumbers last;
}
public class LinkedListCharacters{
	public LinkedListNodeCharacters first;
	public LinkedListNodeCharacters last;
}
public class LinkedListNodeCharacters{
	public bool end;
	public char value;
	public LinkedListNodeCharacters next;
}
public class DynamicArrayNumbers{
	public double [] array;
	public double length;
}
public class Matrices{
	public static void Add(Matrix a, Matrix b){
		double m, n;
		double r, c;

		r = NumberOfRows(a);
		c = NumberOfColumns(a);
		for(m = 0d; m < r; m = m + 1d){
			for(n = 0d; n < c; n = n + 1d){
				a.r[(int)(m)].c[(int)(n)] = Element(a, m, n) + Element(b, m, n);
			}
		}
	}


	public static void Assign(Matrix A, Matrix B){
		double m, n;
		double r, c;

		r = NumberOfRows(A);
		c = NumberOfColumns(A);
		for(m = 0d; m < r; m = m + 1d){
			for(n = 0d; n < c; n = n + 1d){
				A.r[(int)(m)].c[(int)(n)] = Element(B, m, n);
			}
		}
	}


	public static void Resize(Matrix A, double r, double c){
		double m, n, ar, ac;
		Matrix C;

		C = CreateMatrix(r, c);

		ar = NumberOfRows(A);
		ac = NumberOfColumns(A);

		for(m = 0d; m < Min(r, ar); m = m + 1d){
			for(n = 0d; n < Min(c, ac); n = n + 1d){
				C.r[(int)(m)].c[(int)(n)] = Element(A, m, n);
			}
		}

		FreeMatrixRows(A.r);
		A.r = C.r;
	}


	public static void Subtract(Matrix a, Matrix b){
		double m, n;
		double r, c;

		r = NumberOfRows(a);
		c = NumberOfColumns(a);
		for(m = 0d; m < r; m = m + 1d){
			for(n = 0d; n < c; n = n + 1d){
				a.r[(int)(m)].c[(int)(n)] = Element(a, m, n) - Element(b, m, n);
			}
		}
	}


	public static Matrix SubtractToNew(Matrix a, Matrix b){
		Matrix X;

		X = CreateCopyOfMatrix(a);
		Subtract(X, b);

		return X;
	}


	public static void ScalarMultiply(Matrix A, double b){
		double m, n;
		double r, c;

		r = NumberOfRows(A);
		c = NumberOfColumns(A);
		for(m = 0d; m < r; m = m + 1d){
			for(n = 0d; n < c; n = n + 1d){
				A.r[(int)(m)].c[(int)(n)] = b*A.r[(int)(m)].c[(int)(n)];
			}
		}
	}


	public static void ScalarDivide(Matrix A, double b){
		double m, n;
		double r, c;

		r = NumberOfRows(A);
		c = NumberOfColumns(A);
		for(m = 0d; m < r; m = m + 1d){
			for(n = 0d; n < c; n = n + 1d){
				A.r[(int)(m)].c[(int)(n)] = Element(A, m, n)/b;
			}
		}
	}


	public static void ElementWisePower(Matrix A, double p){
		double m, n;
		double r, c;

		r = NumberOfRows(A);
		c = NumberOfColumns(A);

		for(m = 0d; m < r; m = m + 1d){
			for(n = 0d; n < c; n = n + 1d){
				A.r[(int)(m)].c[(int)(n)] = Pow(A.r[(int)(m)].c[(int)(n)], p);
			}
		}
	}


	public static Matrix ScalarMultiplyToNew(Matrix A, double b){
		Matrix matrix;

		matrix = CreateCopyOfMatrix(A);
		ScalarMultiply(matrix, b);

		return matrix;
	}


	public static Matrix MultiplyToNew(Matrix a, Matrix b){
		double rows, cols;
		Matrix x;

		rows = NumberOfRows(a);
		cols = NumberOfColumns(b);
		x = CreateMatrix(rows, cols);
		Multiply(x, a, b);

		return x;
	}


	public static void Multiply(Matrix x, Matrix a, Matrix b){
		double m, n;
		double rows, cols, d;
		double i, s;

		rows = NumberOfRows(a);
		cols = NumberOfColumns(b);
		d = NumberOfColumns(a);

		for(m = 0d; m < rows; m = m + 1d){
			for(n = 0d; n < cols; n = n + 1d){
				s = 0d;

				for(i = 0d; i < d; i = i + 1d){
					s = s + a.r[(int)(m)].c[(int)(i)]*b.r[(int)(i)].c[(int)(n)];
				}

				x.r[(int)(m)].c[(int)(n)] = s;
			}
		}
	}


	public static Matrix CreateSquareMatrix(double d){
		double m, n;
		Matrix matrix;

		matrix = new Matrix();
		matrix.r = new MatrixRow [(int)(d)];
		for(m = 0d; m < d; m = m + 1d){
			matrix.r[(int)(m)] = new MatrixRow();
			matrix.r[(int)(m)].c = new double [(int)(d)];
			for(n = 0d; n < d; n = n + 1d){
				matrix.r[(int)(m)].c[(int)(n)] = 0d;
			}
		}

		return matrix;
	}


	public static Matrix CreateMatrix(double rows, double cols){
		double m, n;
		Matrix matrix;

		matrix = new Matrix();
		matrix.r = new MatrixRow [(int)(rows)];
		for(m = 0d; m < rows; m = m + 1d){
			matrix.r[(int)(m)] = new MatrixRow();
			matrix.r[(int)(m)].c = new double [(int)(cols)];
			for(n = 0d; n < cols; n = n + 1d){
				matrix.r[(int)(m)].c[(int)(n)] = 0d;
			}
		}

		return matrix;
	}


	public static Matrix CreateIdentityMatrix(double d){
		double m;
		Matrix matrix;

		matrix = CreateSquareMatrix(d);
		Fill(matrix, 0d);

		for(m = 0d; m < d; m = m + 1d){
			matrix.r[(int)(m)].c[(int)(m)] = 1d;
		}

		return matrix;
	}


	public static void Transpose(Matrix a){
		Matrix ap;

		ap = TransposeToNew(a);

		FreeMatrixRows(a.r);
		a.r = ap.r;
	}


	public static void TransposeAssign(Matrix t, Matrix a){
		double m, n;
		double rows, cols;

		cols = NumberOfRows(a);
		rows = NumberOfColumns(a);

		for(m = 0d; m < cols; m = m + 1d){
			for(n = 0d; n < rows; n = n + 1d){
				t.r[(int)(n)].c[(int)(m)] = a.r[(int)(m)].c[(int)(n)];
			}
		}
	}


	public static Matrix TransposeToNew(Matrix a){
		double m, n;
		double rows, cols;
		Matrix c;

		cols = NumberOfRows(a);
		rows = NumberOfColumns(a);

		c = CreateMatrix(rows, cols);

		for(m = 0d; m < cols; m = m + 1d){
			for(n = 0d; n < rows; n = n + 1d){
				c.r[(int)(n)].c[(int)(m)] = a.r[(int)(m)].c[(int)(n)];
			}
		}

		return c;
	}


	public static void CofactorOfMatrix(Matrix mat, Matrix temp, double p, double q, double n){
		double i, j;
		double row, col;

		i = 0d;
		j = 0d;

		for(row = 0d; row < n; row = row + 1d){
			for(col = 0d; col < n; col = col + 1d){
				if(row != p && col != q){
					temp.r[(int)(i)].c[(int)(j)] = mat.r[(int)(row)].c[(int)(col)];
					j = j + 1d;

					if(j == n - 1d){
						j = 0d;
						i = i + 1d;
					}
				}
			}
		}
	}


	public static double DeterminantOfSubmatrix(Matrix mat, double n){
		double D, f, sign;
		Matrix temp;

		D = 0d;

		if(n == 1d){
			D = mat.r[0].c[0];
		}else{
			temp = CreateSquareMatrix(n);

			sign = 1d;

			for(f = 0d; f < n; f = f + 1d){
				CofactorOfMatrix(mat, temp, 0d, f, n);
				D = D + sign*mat.r[0].c[(int)(f)]*DeterminantOfSubmatrix(temp, n - 1d);
				sign = -sign;
			}

			FreeMatrix(temp);
		}

		return D;
	}


	public static double Determinant(Matrix m){
		double D, n;

		n = NumberOfRows(m);
		D = DeterminantOfSubmatrix(m, n);

		return D;
	}


	public static void Adjoint(Matrix A, Matrix adj){
		double n, sign;
		Matrix cofactors;
		double i, j;

		n = A.r.Length;

		if(n == 1d){
			adj.r[0].c[0] = 1d;
		}else{
			cofactors = CreateSquareMatrix(n);

			for(i = 0d; i < n; i = i + 1d){
				for(j = 0d; j < n; j = j + 1d){
					CofactorOfMatrix(A, cofactors, i, j, n);

					if((i + j)%2d == 0d){
						sign = 1d;
					}else{
						sign = -1d;
					}

					adj.r[(int)(j)].c[(int)(i)] = sign*DeterminantOfSubmatrix(cofactors, n - 1d);
				}
			}

			FreeMatrix(cofactors);
		}
	}


	public static bool Inverse(Matrix A, Matrix inverseResult){
		return InverseUsingLUDecomposition(A, inverseResult);
	}


	public static bool InverseUsingAdjoint(Matrix A, Matrix inverseResult){
		bool success;
		Matrix adj;
		double n, i, j;
		double det;

		if(NumberOfColumns(A) == NumberOfRows(A)){
			n = NumberOfColumns(A);

			det = Determinant(A);
			if(det != 0d){
				adj = CreateSquareMatrix(n);
				Adjoint(A, adj);

				for(i = 0d; i < n; i = i + 1d){
					for(j = 0d; j < n; j = j + 1d){
						inverseResult.r[(int)(i)].c[(int)(j)] = adj.r[(int)(i)].c[(int)(j)]/det;
					}
				}

				success = true;
				FreeMatrix(adj);
			}else{
				success = false;
			}
		}else{
			success = false;
		}

		return success;
	}


	public static bool InverseUsingLUDecomposition(Matrix A, Matrix inverseResult){
		bool success;
		Matrix l, u, li, ui;

		l = CreateCopyOfMatrix(A);
		u = CreateCopyOfMatrix(A);
		li = CreateCopyOfMatrix(A);
		ui = CreateCopyOfMatrix(A);
		inverseResult.r = CreateCopyOfMatrix(A).r;

		success = LUDecomposition(A, l, u);
		if(success){
			success = InvertLowerTriangularMatrix(l, li);
			if(success){
				success = InvertUpperTriangularMatrix(u, ui);
				if(success){
					Multiply(inverseResult, ui, li);
				}
			}
		}

		FreeMatrix(l);
		FreeMatrix(u);
		FreeMatrix(li);
		FreeMatrix(ui);

		return success;
	}


	public static bool LUDecomposition(Matrix A, Matrix L, Matrix U){
		double n, i, j, k, sum;
		bool success;

		n = NumberOfRows(A);

		L.r = CreateSquareMatrix(n).r;
		U.r = CreateSquareMatrix(n).r;

		if(IsSquare(A)){
			success = true;

			for(i = 0d; i < n && success; i = i + 1d){
				for(k = i; k < n; k = k + 1d){
					sum = 0d;
					for(j = 0d; j < i; j = j + 1d){
						sum = sum + (Element(L, i, j)*Element(U, j, k));
					}

					U.r[(int)(i)].c[(int)(k)] = Element(A, i, k) - sum;
				}

				for(k = i; k < n && success; k = k + 1d){
					if(i == k){
						L.r[(int)(i)].c[(int)(i)] = 1d;
					}else{
						sum = 0d;
						for(j = 0d; j < i; j = j + 1d){
							sum = sum + (Element(L, k, j)*Element(U, j, i));
						}

						if(Element(U, i, i) == 0d){
							success = false;
						}else{
							L.r[(int)(k)].c[(int)(i)] = (Element(A, k, i) - sum)/Element(U, i, i);
						}
					}
				}
			}
		}else{
			success = false;
		}

		return success;
	}


	public static bool IsSymmetric(Matrix A){
		double N;
		double i, j;
		bool isx, done;

		N = NumberOfRows(A);

		done = false;
		isx = true;
		for(i = 0d; i < N && !done; i = i + 1d){
			for(j = 0d; j < i && !done; j = j + 1d){
				if(A.r[(int)(i)].c[(int)(j)] != A.r[(int)(j)].c[(int)(i)]){
					isx = false;
					done = true;
				}
			}
		}

		return isx;
	}


	public static bool IsSquare(Matrix A){
		bool isx;

		if(NumberOfRows(A) == NumberOfColumns(A)){
			isx = true;
		}else{
			isx = false;
		}

		return isx;
	}


	public static bool Cholesky(Matrix A, Matrix L){
		bool success;
		double N;
		double i, j, k, s;

		Clear(L);

		if(IsSquare(A) && IsSymmetric(A)){
			success = true;

			N = NumberOfRows(A);

			for(i = 0d; i < N && success; i = i + 1d){
				for(j = 0d; j <= i && success; j = j + 1d){
					s = 0d;
					for(k = 0d; k < j; k = k + 1d){
						s = s + L.r[(int)(i)].c[(int)(k)]*L.r[(int)(j)].c[(int)(k)];
					}
					if(i == j){
						L.r[(int)(i)].c[(int)(i)] = Sqrt(A.r[(int)(i)].c[(int)(i)] - s);
					}else{
						L.r[(int)(i)].c[(int)(j)] = 1d/L.r[(int)(j)].c[(int)(j)]*(A.r[(int)(i)].c[(int)(j)] - s);
					}
				}
				if(L.r[(int)(i)].c[(int)(i)] <= 0d){
					success = false;
				}
			}

			success = true;
		}else{
			success = false;
		}

		return success;
	}


	public static void Clear(Matrix a){
		Fill(a, 0d);
	}


	public static void Fill(Matrix a, double value){
		double m, n;

		for(m = 0d; m < NumberOfRows(a); m = m + 1d){
			for(n = 0d; n < NumberOfColumns(a); n = n + 1d){
				a.r[(int)(m)].c[(int)(n)] = value;
			}
		}
	}


	public static double Element(Matrix matrix, double m, double n){
		return matrix.r[(int)(m)].c[(int)(n)];
	}


	public static double Trace(Matrix a){
		double m;
		double d, tr;

		tr = 0d;

		d = a.r.Length;
		for(m = 0d; m < d; m = m + 1d){
			tr = tr + a.r[(int)(m)].c[(int)(m)];
		}

		return tr;
	}


	public static Matrix ColumnCombineMatricesToNew(Matrix A, Matrix B){
		Matrix X;
		double m, n;

		X = CreateMatrix(NumberOfRows(A), NumberOfColumns(A) + NumberOfColumns(B));

		for(m = 0d; m < NumberOfRows(A); m = m + 1d){
			for(n = 0d; n < NumberOfColumns(A); n = n + 1d){
				X.r[(int)(m)].c[(int)(n)] = A.r[(int)(m)].c[(int)(n)];
			}
		}

		for(m = 0d; m < NumberOfRows(B); m = m + 1d){
			for(n = 0d; n < NumberOfColumns(B); n = n + 1d){
				X.r[(int)(m)].c[(int)(NumberOfColumns(A) + n)] = B.r[(int)(m)].c[(int)(n)];
			}
		}

		return X;
	}


	public static double NumberOfRows(Matrix A){
		return A.r.Length;
	}


	public static double NumberOfColumns(Matrix A){
		return A.r[0].c.Length;
	}


	public static double [] CharacteristicPolynomial(Matrix A){
		Matrix dummy;
		NumberArrayReference coeffs;
		NumberReference determinant;

		dummy = CreateSquareMatrix(NumberOfRows(A));

		coeffs = new NumberArrayReference();
		determinant = new NumberReference();
		CharacteristicPolynomialWithInverse(A, dummy, coeffs, determinant);

		FreeMatrix(dummy);

		return coeffs.numberArray;
	}


	public static void CharacteristicPolynomialWithInverse(Matrix A, Matrix AInverse, NumberArrayReference cp, NumberReference determinant){
		FaddeevLeVerrierAlgorithm(A, AInverse, cp, determinant);
	}


	public static void FaddeevLeVerrierAlgorithm(Matrix A, Matrix AInverse, NumberArrayReference cp, NumberReference determinant){
		double [] p;
		Matrix Mk, Mkm1, t1, I;
		double n, k;

		n = NumberOfRows(A);
		p = new double [(int)(n + 1d)];
		p[(int)(n)] = 1d;
		Mkm1 = CreateSquareMatrix(n);
		Fill(Mkm1, 0d);
		I = CreateIdentityMatrix(n);
		Mk = CreateSquareMatrix(n);
		t1 = CreateSquareMatrix(n);

		for(k = 1d; k <= n; k = k + 1d){
			/* M_k = A * M_(k-1) + c_(n-k+1) * I*/
			Multiply(Mk, A, Mkm1);
			Assign(t1, I);
			ScalarMultiply(t1, p[(int)(n - k + 1d)]);
			Add(Mk, t1);

			/* c_(n-k) = -1/k * trace(A * M_k)*/
			Multiply(t1, A, Mk);
			p[(int)(n - k)] = -1d/k*Trace(t1);

			/* done*/
			Assign(Mkm1, Mk);

			if(k == n){
				Assign(AInverse, Mk);
				determinant.numberValue = -p[0];
				if(p[0] == 0d){
				}else{
					ScalarDivide(AInverse, determinant.numberValue);
				}
			}
		}

		FreeMatrix(Mkm1);
		FreeMatrix(I);
		FreeMatrix(Mk);
		FreeMatrix(t1);

		cp.numberArray = p;
	}


	public static Matrix InverseUsingCharacteristicPolynomial(Matrix A){
		Matrix inverse;
		NumberArrayReference coeffs;
		NumberReference determinant;

		inverse = CreateSquareMatrix(NumberOfRows(A));
		coeffs = new NumberArrayReference();
		determinant = new NumberReference();
		CharacteristicPolynomialWithInverse(A, inverse, coeffs, determinant);
		delete(coeffs.numberArray);
		delete(coeffs);

		return inverse;
	}


	public static bool Eigenvalues(Matrix A, NumberArrayReference eigenValuesReference){
		MatrixArrayReference eigenVectorsReference;
		bool success;
		double i;

		eigenVectorsReference = new MatrixArrayReference();
		success = Eigenpairs(A, eigenValuesReference, eigenVectorsReference);
		if(success){
			for(i = 0d; i < eigenVectorsReference.matrices.Length; i = i + 1d){
				FreeMatrix(eigenVectorsReference.matrices[(int)(i)]);
			}
			delete(eigenVectorsReference.matrices);
			delete(eigenVectorsReference);
		}

		return success;
	}


	public static bool EigenvaluesUsingQRAlgorithm(Matrix A, NumberArrayReference eigenValuesReference, double precision, double maxIterations){
		Matrix x, q, r;
		bool success;
		double i, n, v, v1, v2, ev, found;
		double [] cp;

		n = NumberOfRows(A);
		x = CreateSquareMatrix(n);
		q = CreateSquareMatrix(n);
		r = CreateSquareMatrix(n);
		eigenValuesReference.numberArray = new double [(int)(n)];
		success = QRAlgorithm(A, r, x, q, precision, maxIterations);
		found = 0d;
		if(success){
			ExtractDiagonal(x, eigenValuesReference.numberArray);

			/* find the correct sign of the eigenvalue.*/
			cp = CharacteristicPolynomial(A);
			for(i = 0d; i < n; i = i + 1d){
				ev = eigenValuesReference.numberArray[(int)(i)];

				v1 = pEvaluate(cp, ev);
				v2 = pEvaluate(cp, -ev);

				if(Abs(v2) < Abs(v1)){
					eigenValuesReference.numberArray[(int)(i)] = -ev;
					v = v2;
				}else{
					v = v1;
				}

				if(Abs(v) < precision*Pow(10d, 4d)){
					found = found + 1d;
				}
			}

			FreeMatrix(x);
			FreeMatrix(q);
			FreeMatrix(r);
		}

		if(found != n){
			success = false;
		}

		return success;
	}


	public static bool EigenvaluesUsingLaguerreIterations(Matrix A, NumberArrayReference eigenValuesReference){
		double [] p;
		bool success;

		p = CharacteristicPolynomial(A);
		success = FindRoots(p, eigenValuesReference);

		return success;
	}


	public static void GaussianElimination(Matrix A){
		double h, k, m, n, maxElement, i, j, max, maxCandidate, f;

		m = NumberOfRows(A);
		n = NumberOfColumns(A);

		h = 0d;
		k = 0d;
		for(; h < m && k < n; ){
			maxElement = h;
			max = 0d;
			for(i = h; i < m; i = i + 1d){
				maxCandidate = Abs(Element(A, i, k));
				if(max < maxCandidate){
					maxElement = i;
					max = maxCandidate;
				}
			}
			if(A.r[(int)(maxElement)].c[(int)(k)] == 0d){
				k = k + 1d;
			}else{
				SwapRows(A, h, maxElement);
				for(i = h + 1d; i < m; i = i + 1d){
					f = Element(A, i, k)/Element(A, h, k);
					A.r[(int)(i)].c[(int)(k)] = 0d;
					for(j = k + 1d; j < n; j = j + 1d){
						A.r[(int)(i)].c[(int)(j)] = Element(A, i, j) - Element(A, h, j)*f;
					}
				}
				h = h + 1d;
				k = k + 1d;
			}
		}
	}


	public static Matrix GaussianEliminationToNew(Matrix A){
		Matrix X;

		X = CreateCopyOfMatrix(A);
		GaussianElimination(X);

		return X;
	}


	public static Matrix CreateCopyOfMatrix(Matrix A){
		Matrix X;

		X = CreateMatrix(NumberOfRows(A), NumberOfColumns(A));
		Assign(X, A);

		return X;
	}


	public static void SwapRows(Matrix A, double to, double from){
		double n;
		double c, t;

		c = NumberOfRows(A);
		for(n = 0d; n < c; n = n + 1d){
			t = A.r[(int)(to)].c[(int)(n)];
			A.r[(int)(to)].c[(int)(n)] = A.r[(int)(from)].c[(int)(n)];
			A.r[(int)(from)].c[(int)(n)] = t;
		}
	}


	public static void UnnormalizeVector(double [] numberArray){
		double i, m;
		bool mSet;

		mSet = false;
		m = 0d;

		for(i = 0d; i < numberArray.Length; i = i + 1d){
			if(numberArray[(int)(i)] - mathTruncate(numberArray[(int)(i)]) < 0.001){
				if(!mSet){
					m = Abs(numberArray[(int)(i)]);
					mSet = true;
				}else{
					m = Min(m, Abs(numberArray[(int)(i)]));
				}
			}
		}

		if(mSet){
			for(i = 0d; i < numberArray.Length; i = i + 1d){
				numberArray[(int)(i)] = numberArray[(int)(i)]/m;
			}
		}
	}


	public static bool InversePowerMethod(Matrix A, double eigenvalue, double maxIterations, NumberArrayReference eigenvector){
		Matrix x, y, z, b, t;
		double n, i, c;
		bool singular;

		n = NumberOfRows(A);

		x = CreateIdentityMatrix(n);
		ScalarMultiply(x, eigenvalue);
		y = SubtractToNew(A, x);
		z = CreateSquareMatrix(n);
		singular = !Inverse(y, z);
		if(singular){
			/* Try again with more erroneous eigenvalue estimate.*/
			x = CreateIdentityMatrix(n);
			ScalarMultiply(x, eigenvalue*1.01);
			y = SubtractToNew(A, x);
			z = CreateSquareMatrix(n);
			singular = !Inverse(y, z);
		}

		if(!singular){
			b = CreateMatrix(n, 1d);

			for(i = 0d; i < n; i = i + 1d){
				b.r[(int)(i)].c[0] = 1d;
			}

			for(i = 0d; i < maxIterations; i = i + 1d){
				t = MultiplyToNew(z, b);
				c = Norm(t);
				ScalarDivide(t, c);
				Assign(b, t);
			}

			eigenvector.numberArray = new double [(int)(n)];
			for(i = 0d; i < n; i = i + 1d){
				eigenvector.numberArray[(int)(i)] = b.r[(int)(i)].c[0];
			}
		}

		return !singular;
	}


	public static bool Eigenvectors(Matrix A, MatrixArrayReference eigenVectorsReference){
		NumberArrayReference evsReference;
		bool success;

		evsReference = new NumberArrayReference();
		success = Eigenpairs(A, evsReference, eigenVectorsReference);
		if(success){
			delete(evsReference.numberArray);
			delete(evsReference);
		}

		return success;
	}


	public static bool Eigenpairs(Matrix A, NumberArrayReference eigenValuesReference, MatrixArrayReference eigenVectorsReference){
		return EigenpairsUsingQRAlgorithmAndInversePowerMethod(A, eigenValuesReference, eigenVectorsReference, 0.00000000001, 100d);
	}


	public static bool EigenpairsUsingQRAlgorithmAndInversePowerMethod(Matrix M, NumberArrayReference eigenValuesReference, MatrixArrayReference eigenVectorsReference, double precision, double maxIterations){
		NumberArrayReference evecReference;
		bool done, inverseSuccess;
		double i, j, k, N, v1, v2, eigenValue, withinPrecision;
		Matrix A, Q, R, eigenVector;
		double [] cp;

		N = NumberOfRows(M);

		A = CreateCopyOfMatrix(M);
		Q = CreateCopyOfMatrix(M);
		R = CreateCopyOfMatrix(M);

		done = false;
		eigenVectorsReference.matrices = new Matrix [(int)(N)];
		evecReference = new NumberArrayReference();
		eigenValuesReference.numberArray = new double [(int)(N)];
		cp = CharacteristicPolynomial(M);

		for(j = 0d; j < N; j = j + 1d){
			eigenVectorsReference.matrices[(int)(j)] = CreateMatrix(N, 1d);
		}

		for(i = 0d; i < maxIterations && !done; i = i + 1d){
			QRDecomposition(A, Q, R);
			Multiply(A, R, Q);

			/* Check*/
			withinPrecision = 0d;
			ExtractDiagonal(R, eigenValuesReference.numberArray);

			for(j = 0d; j < N; j = j + 1d){
				/* Find the correct sign of the eigenvalue.*/
				eigenValue = eigenValuesReference.numberArray[(int)(j)];
				v1 = pEvaluate(cp, eigenValue);
				v2 = pEvaluate(cp, -eigenValue);
				if(Abs(v2) < Abs(v1)){
					eigenValuesReference.numberArray[(int)(j)] = -eigenValue;
					eigenValue = -eigenValue;
				}

				/* Calculate the eigenvector corresponding to the eigenvalue.*/
				inverseSuccess = InversePowerMethod(M, eigenValue, i + 1d, evecReference);
				if(inverseSuccess){
					for(k = 0d; k < N; k = k + 1d){
						eigenVectorsReference.matrices[(int)(j)].r[(int)(k)].c[0] = evecReference.numberArray[(int)(k)];
					}

					/* Check eigenpair agains precision.*/
					eigenVector = eigenVectorsReference.matrices[(int)(j)];

					if(CheckEigenpairPrecision(M, eigenValue, eigenVector, precision)){
						withinPrecision = withinPrecision + 1d;
					}
				}
			}

			if(withinPrecision == N){
				done = true;
			}
		}

		FreeMatrix(A);
		FreeMatrix(Q);
		FreeMatrix(R);
		delete(evecReference);
		delete(cp);

		return done;
	}


	public static bool CheckEigenpairPrecision(Matrix a, double lambda, Matrix e, double precision){
		Matrix vec1, vec2;
		bool equal;

		vec1 = MultiplyToNew(a, e);
		vec2 = ScalarMultiplyToNew(e, lambda);

		equal = MatrixEqualsEpsilon(vec1, vec2, precision);

		return equal;
	}


	public static bool EigenvectorsLaguerreIterationsAndGaussianEliminations(Matrix A, MatrixArrayReference eigenVectorsReference){
		Matrix Id, t1, B, v;
		Matrix [] eigenVectorsResult;
		bool success;
		NumberArrayReference eigenValuesReference;
		double i, lambda, j, N, x, k;
		double [] ev;

		N = NumberOfRows(A);

		eigenValuesReference = new NumberArrayReference();
		success = Eigenvalues(A, eigenValuesReference);

		eigenVectorsResult = new Matrix [(int)(N)];

		if(success){
			ev = eigenValuesReference.numberArray;

			Id = CreateIdentityMatrix(N);
			t1 = CreateSquareMatrix(N);
			B = CreateSquareMatrix(N);

			for(j = 0d; j < ev.Length && success; j = j + 1d){
				lambda = ev[(int)(j)];

				/* B = A - lambda * Id*/
				Assign(t1, Id);
				ScalarMultiply(t1, lambda);

				Assign(B, A);
				Subtract(B, t1);

				GaussianElimination(B);

				v = CreateMatrix(N, 1d);
				v.r[(int)(N - 1d)].c[0] = 1d;
				for(i = N - 2d; i >= 0d && success; i = i - 1d){
					if(!RowIsZero(B, i)){
						x = 0d;

						for(k = N - 1d; k > i; k = k - 1d){
							x = x - Element(B, i, k)*Element(v, k, 0d);
						}

						v.r[(int)(i)].c[0] = x/Element(B, i, i);
					}else{
						success = false;
					}
				}

				eigenVectorsResult[(int)(j)] = v;
			}

			FreeMatrix(t1);
			FreeMatrix(B);
			FreeMatrix(Id);

			eigenVectorsReference.matrices = eigenVectorsResult;
		}

		return success;
	}


	public static bool RowIsZero(Matrix X, double r){
		bool isZero;
		double columns, i;

		isZero = true;

		columns = NumberOfColumns(X);
		for(i = 0d; i < columns && isZero; i = i + 1d){
			if(Element(X, r, i) != 0d){
				isZero = false;
			}
		}

		return isZero;
	}


	public static void FreeMatrix(Matrix X){
		FreeMatrixRows(X.r);
		delete(X);
	}


	public static void FreeMatrixRows(MatrixRow [] r){
		double m, rows;

		rows = r.Length;
		for(m = 0d; m < rows; m = m + 1d){
			delete(r[(int)(m)].c);
			delete(r[(int)(m)]);
		}

		delete(r);
	}


	public static Matrix CreateDiagonalMatrixFromArray(double [] array){
		double m;
		Matrix matrix;

		matrix = CreateSquareMatrix(array.Length);
		Fill(matrix, 0d);

		for(m = 0d; m < array.Length; m = m + 1d){
			matrix.r[(int)(m)].c[(int)(m)] = array[(int)(m)];
		}

		return matrix;
	}


	public static Matrix CreateMatrixFromRowCopies(double [] row, double times){
		double m, n;
		Matrix matrix;

		matrix = CreateMatrix(times, row.Length);

		for(m = 0d; m < times; m = m + 1d){
			for(n = 0d; n < row.Length; n = n + 1d){
				matrix.r[(int)(m)].c[(int)(n)] = row[(int)(n)];
			}
		}

		return matrix;
	}


	public static void ExtractDiagonal(Matrix X, double [] diag){
		double n, i;

		n = NumberOfRows(X);

		for(i = 0d; i < n; i = i + 1d){
			diag[(int)(i)] = X.r[(int)(i)].c[(int)(i)];
		}
	}


	public static double [] ExtractDiagonalToNew(Matrix X){
		double [] diag;
		double n, i;

		n = NumberOfRows(X);
		diag = new double [(int)(n)];

		for(i = 0d; i < n; i = i + 1d){
			diag[(int)(i)] = X.r[(int)(i)].c[(int)(i)];
		}

		return diag;
	}


	public static bool MatrixEqualsEpsilon(Matrix a, Matrix b, double epsilon){
		double x, y, columns, rows;
		bool equals;

		equals = true;

		if(NumberOfRows(a) == NumberOfRows(b) && NumberOfColumns(a) == NumberOfColumns(b)){
			columns = NumberOfColumns(a);
			rows = NumberOfRows(a);

			for(x = 0d; x < rows; x = x + 1d){
				for(y = 0d; y < columns; y = y + 1d){
					equals = equals && mathEpsilonCompare(Element(a, x, y), Element(b, x, y), epsilon);
				}
			}
		}else{
			equals = false;
		}

		return equals;
	}


	public static Matrix Minor(Matrix x, double row, double column){
		Matrix theMinor;
		double cols, rows, i, j, m, n;

		rows = NumberOfRows(x) - 1d;
		cols = NumberOfColumns(x) - 1d;

		theMinor = CreateMatrix(rows, cols);

		for(i = 0d; i < rows; i = i + 1d){
			if(i < row){
				m = i;
			}else{
				m = i + 1d;
			}

			for(j = 0d; i != row && j < cols; j = j + 1d){
				if(j != column){

					if(j < column){
						n = j;
					}else{
						n = j + 1d;
					}

					theMinor.r[(int)(m)].c[(int)(n)] = x.r[(int)(i)].c[(int)(j)];
				}
			}
		}

		return theMinor;
	}


	public static void QRDecomposition(Matrix m, Matrix Q, Matrix R){
		HouseholderMethod(m, Q, R);
	}


	public static void HouseholderTriangularizationAlgorithm(Matrix m, Matrix Qout, Matrix Rout){
		Matrix P, AA, A, PP, v, vt, t;
		double i, j, rows, cols, r, s;

		rows = NumberOfRows(m);
		cols = NumberOfColumns(m);

		P = CreateIdentityMatrix(rows);
		A = CreateCopyOfMatrix(m);
		AA = CreateMatrix(rows, cols);

		t = CreateMatrix(rows, cols);
		PP = CreateIdentityMatrix(rows);
		vt = CreateMatrix(1d, rows);

		for(j = 0d; j < cols; j = j + 1d){
			v = ExtractSubMatrix(A, 0d, rows - 1d, j, j);
			if(j > 0d){
				for(i = 0d; i < j; i = i + 1d){
					v.r[(int)(i)].c[0] = 0d;
				}
			}

			s = mathSign(v.r[(int)(j)].c[0]);
			if(s == 0d){
				s = 1d;
			}
			v.r[(int)(j)].c[0] = v.r[(int)(j)].c[0] + Norm(v)*s;
			r = -2d/(Norm(v)*Norm(v));
			Assign(AA, A);

			TransposeAssign(vt, v);
			Multiply(t, vt, A);
			Assign(A, t);
			Multiply(t, v, A);
			Assign(A, t);
			ScalarMultiply(A, r);
			Assign(t, AA);
			Add(A, AA);

			Assign(PP, P);

			Multiply(t, vt, P);
			Assign(P, t);
			Multiply(t, v, P);
			Assign(P, t);
			ScalarMultiply(P, r);
			Assign(t, AA);
			Add(P, PP);
		}

		Assign(Rout, A);
		Assign(Qout, P);
		Transpose(Qout);
	}


	public static void HouseholderMethod(Matrix A, Matrix q, Matrix r){
		Matrix QR, R, Q;
		double [] Rdiag;
		double m, n;
		double i, j, k;
		double s, nrm;
		double e;
		Matrix N, ra, rq;

		/* Initialize.*/
		QR = CreateCopyOfMatrix(A);
		m = NumberOfRows(A);
		n = NumberOfColumns(A);
		Rdiag = new double [(int)(n)];

		/* Main loop.*/
		for(k = 0d; k < n; k = k + 1d){
			/* Compute 2-norm of k-th column without under/overflow.*/
			nrm = 0d;
			for(i = k; i < m; i = i + 1d){
				nrm = Hypothenuse(nrm, Element(QR, i, k));
			}

			if(nrm != 0d){
				/* Form k-th Householder vector.*/
				if(Element(QR, k, k) < 0d){
					nrm = -nrm;
				}
				for(i = k; i < m; i = i + 1d){
					QR.r[(int)(i)].c[(int)(k)] = Element(QR, i, k)/nrm;
				}
				QR.r[(int)(k)].c[(int)(k)] = Element(QR, k, k) + 1d;

				/* Apply transformation to remaining columns.*/
				for(j = k + 1d; j < n; j = j + 1d){
					s = 0d;
					for(i = k; i < m; i = i + 1d){
						s = s + Element(QR, i, k)*Element(QR, i, j);
					}
					s = -s/Element(QR, k, k);
					for(i = k; i < m; i = i + 1d){
						QR.r[(int)(i)].c[(int)(j)] = Element(QR, i, j) + s*Element(QR, i, k);
					}
				}
			}
			Rdiag[(int)(k)] = -nrm;
		}

		/* Compute R*/
		R = CreateSquareMatrix(n);
		for(i = 0d; i < n; i = i + 1d){
			for(j = 0d; j < n; j = j + 1d){
				if(i < j){
					R.r[(int)(i)].c[(int)(j)] = Element(QR, i, j);
				}else if(i == j){
					R.r[(int)(i)].c[(int)(j)] = Rdiag[(int)(i)];
				}else{
					R.r[(int)(i)].c[(int)(j)] = 0d;
				}
			}
		}
		Assign(r, R);

		/* Compute Q*/
		Q = CreateMatrix(m, n);
		for(k = n - 1d; k >= 0d; k = k - 1d){
			for(i = 0d; i < m; i = i + 1d){
				Q.r[(int)(i)].c[(int)(k)] = 0d;
			}
			Q.r[(int)(k)].c[(int)(k)] = 1d;
			for(j = k; j < n; j = j + 1d){
				if(Element(QR, k, k) != 0d){
					s = 0d;
					for(i = k; i < m; i = i + 1d){
						s = s + Element(QR, i, k)*Element(Q, i, j);
					}
					s = -s/Element(QR, k, k);
					for(i = k; i < m; i = i + 1d){
						Q.r[(int)(i)].c[(int)(j)] = Element(Q, i, j) + s*Element(QR, i, k);
					}
				}
			}
		}
		Assign(q, Q);

		/* Adjust for positive R.*/
		n = NumberOfRows(r);

		N = CreateIdentityMatrix(n);

		for(i = 0d; i < n; i = i + 1d){
			e = Element(r, i, i);

			if(e < 0d){
				N.r[(int)(i)].c[(int)(i)] = -1d;
			}
		}

		ra = MultiplyToNew(N, r);
		Assign(r, ra);
		rq = MultiplyToNew(q, N);
		Assign(q, rq);

		FreeMatrix(ra);
		FreeMatrix(rq);
		FreeMatrix(Q);
		FreeMatrix(R);
		FreeMatrix(QR);
	}


	public static double Hypothenuse(double a, double b){
		return Sqrt(Pow(a, 2d) + Pow(b, 2d));
	}


	public static double Norm(Matrix a){
		double l, i, j, rows, cols;

		l = 0d;

		rows = NumberOfRows(a);
		cols = NumberOfColumns(a);

		for(i = 0d; i < rows; i = i + 1d){
			for(j = 0d; j < cols; j = j + 1d){
				l = l + a.r[(int)(i)].c[(int)(j)]*a.r[(int)(i)].c[(int)(j)];
			}
		}
		l = Sqrt(l);

		return l;
	}


	public static Matrix ExtractSubMatrix(Matrix M, double r1, double r2, double c1, double c2){
		Matrix A;
		double i, j;

		A = CreateMatrix(r2 - r1 + 1d, c2 - c1 + 1d);

		for(i = r1; i <= r2; i = i + 1d){
			for(j = c1; j <= c2; j = j + 1d){
				A.r[(int)(i - r1)].c[(int)(j - c1)] = M.r[(int)(i)].c[(int)(j)];
			}
		}

		return A;
	}


	public static bool QRAlgorithm(Matrix M, Matrix R, Matrix A, Matrix Q, double precision, double maxIterations){
		double n, i, j, v;
		double [] previous;
		double withinPrecision;
		bool done, previousSet;

		Assign(A, M);
		n = NumberOfRows(M);
		previous = new double [(int)(n)];
		previousSet = false;

		done = false;
		for(i = 0d; i < maxIterations && !done; i = i + 1d){
			QRDecomposition(A, Q, R);
			Multiply(A, R, Q);

			/* Check precision.*/
			if(previousSet){
				withinPrecision = 0d;
				for(j = 0d; j < n; j = j + 1d){
					v = previous[(int)(j)] - Element(A, j, j);
					if(Abs(v) < precision || v == 0d){
						withinPrecision = withinPrecision + 1d;
					}
				}
				if(withinPrecision == n){
					done = true;
				}
			}

			for(j = 0d; j < n; j = j + 1d){
				previous[(int)(j)] = Element(A, j, j);
			}
			previousSet = true;
		}

		return done;
	}


	public static bool InvertUpperTriangularMatrix(Matrix A, Matrix inverse){
		double sum, i, j, k, n;
		bool success;

		inverse.r = CreateCopyOfMatrix(A).r;
		n = NumberOfRows(inverse);
		success = true;

		for(i = n - 1d; i >= 0d && success; i = i - 1d){
			if(Element(inverse, i, i) == 0d){
				success = false;
			}else{
				inverse.r[(int)(i)].c[(int)(i)] = 1d/Element(inverse, i, i);
				for(j = i - 1d; j >= 0d && success; j = j - 1d){
					sum = 0d;
					for(k = i; k > j; k = k - 1d){
						sum = sum - Element(inverse, j, k)*Element(inverse, k, i);
					}
					if(Element(inverse, j, j) == 0d){
						success = false;
					}else{
						inverse.r[(int)(j)].c[(int)(i)] = sum/Element(inverse, j, j);
					}
				}
			}
		}

		return success;
	}


	public static bool InvertLowerTriangularMatrix(Matrix A, Matrix inverse){
		double sum, i, j, k, n;
		bool success;

		inverse.r = CreateCopyOfMatrix(A).r;
		n = NumberOfRows(inverse);
		success = true;

		for(i = 0d; i < n && success; i = i + 1d){
			if(Element(inverse, i, i) == 0d){
				success = false;
			}else{
				inverse.r[(int)(i)].c[(int)(i)] = 1d/Element(inverse, i, i);
				for(j = i + 1d; j < n; j = j + 1d){
					sum = 0d;
					for(k = i; k < j && success; k = k + 1d){
						sum = sum - Element(inverse, j, k)*Element(inverse, k, i);
					}
					if(Element(inverse, j, j) == 0d){
						success = false;
					}else{
						inverse.r[(int)(j)].c[(int)(i)] = sum/Element(inverse, j, j);
					}
				}
			}
		}

		return success;
	}


	public static bool ParseMatrixFromString(MatrixReference aref, char [] matrixString, StringReference errorMessage){
		bool success;
		StringReference [] lines;
		double rows, cols, i;
		double [] row;
		char [] replaced, trimmed;

		replaced = ReplaceString(matrixString, "\r".ToCharArray(), "".ToCharArray());
		trimmed = Trim(replaced);
		lines = SplitByCharacter(trimmed, '\n');

		delete(replaced);
		delete(trimmed);

		success = true;

		rows = lines.Length;
		if(rows == 0d){
			aref.matrix = CreateMatrix(0d, 0d);
		}else{
			row = nStringToNumberArray(lines[0].stringx);
			cols = row.Length;
			delete(row);

			aref.matrix = CreateMatrix(rows, cols);

			for(i = 0d; i < rows && success; i = i + 1d){
				delete(aref.matrix.r[(int)(i)].c);
				aref.matrix.r[(int)(i)].c = nStringToNumberArray(lines[(int)(i)].stringx);

				if(aref.matrix.r[(int)(i)].c.Length != cols){
					success = false;
					errorMessage.stringx = "All rows must have the same number of columns.".ToCharArray();
				}
			}
		}

		FreeStringReferenceArray(lines);

		return success;
	}


	public static void FreeStringReferenceArray(StringReference [] stringReferencesArray){
		double i;
		for(i = 0d; i < stringReferencesArray.Length; i = i + 1d){
			delete(stringReferencesArray[(int)(i)]);
		}
		delete(stringReferencesArray);
	}


	public static char [] MatrixToString(Matrix matrix, double digitsAfterPoint){
		char [] s1, s2;
		double n, m, element;

		s1 = new char [0];

		for(n = 0d; n < NumberOfRows(matrix); n = n + 1d){
			for(m = 0d; m < NumberOfColumns(matrix); m = m + 1d){
				element = Element(matrix, n, m);
				element = RoundToDigits(element, digitsAfterPoint);
				s2 = AppendString(s1, nCreateStringDecimalFromNumber(element));
				delete(s1);
				s1 = s2;
				if(m + 1d != NumberOfColumns(matrix)){
					s2 = AppendString(s1, ", ".ToCharArray());
					delete(s1);
					s1 = s2;
				}
			}
			s2 = AppendString(s1, "\n".ToCharArray());
			delete(s1);
			s1 = s2;
		}

		return s1;
	}


	public static double RoundToDigits(double element, double digitsAfterPoint){
		return mathRound(element*Pow(10d, digitsAfterPoint))/Pow(10d, digitsAfterPoint);
	}


	public static char [] MatrixArrayToString(Matrix [] matrices, double digitsAfterPoint){
		char [] s1, s2;
		double i;

		s1 = new char [0];

		for(i = 0d; i < matrices.Length; i = i + 1d){
			s2 = AppendString(s1, MatrixToString(matrices[(int)(i)], digitsAfterPoint));
			delete(s1);
			s1 = s2;

			s2 = AppendString(s1, "\n".ToCharArray());
			delete(s1);
			s1 = s2;
		}

		return s1;
	}


	public static void RoundMatrixElementsToDigits(Matrix a, double digits){
		double m, n;

		for(m = 0d; m < NumberOfRows(a); m = m + 1d){
			for(n = 0d; n < NumberOfColumns(a); n = n + 1d){
				a.r[(int)(m)].c[(int)(n)] = RoundToDigits(Element(a, m, n), digits);
				if(a.r[(int)(m)].c[(int)(n)] == -0d){
					a.r[(int)(m)].c[(int)(n)] = 0d;
				}
			}
		}
	}


	public static bool SingularValueDecomposition(Matrix Ap, MatrixReference URef, MatrixReference SigmaRef, MatrixReference VRef){
		Matrix A, U, V;
		double m, n, nu, nct, nrt, i, j, k, t, pp, iter, eps, tiny, kase, f, cs, sn, ks, size, orgm, orgn;
		double scale, sp, spm1, epm1, sk, ek, b, c, shift, g, p;
		bool done;
		double [] s, e, work;

		/* Square matrix, adjust results correspondingly.*/
		orgm = NumberOfRows(Ap);
		orgn = NumberOfColumns(Ap);
		size = Max(orgm, orgn);
		A = CreateCopyOfMatrix(Ap);
		Resize(A, size, size);

		/* Initialize.*/
		m = size;
		n = size;

		/* Compute*/
		nu = Min(m, n);
		s = new double [(int)(Min(m + 1d, n))];
		U = CreateMatrix(m, nu);
		V = CreateSquareMatrix(n);
		e = new double [(int)(n)];
		work = new double [(int)(m)];

		/* Reduce A to bidiagonal form, storing the diagonal elements in s and the super-diagonal elements in e.*/
		nct = Min(m - 1d, n);
		nrt = Max(0d, Min(n - 2d, m));
		for(k = 0d; k < Max(nct, nrt); k = k + 1d){
			if(k < nct){

				/* Compute the transformation for the k-th column and place the k-th diagonal in s[k].*/
				/* Compute 2-norm of k-th column without under/overflow.*/
				s[(int)(k)] = 0d;
				for(i = k; i < m; i = i + 1d){
					s[(int)(k)] = Hypothenuse(s[(int)(k)], Element(A, i, k));
				}
				if(s[(int)(k)] != 0d){
					if(Element(A, k, k) < 0d){
						s[(int)(k)] = -s[(int)(k)];
					}
					for(i = k; i < m; i = i + 1d){
						A.r[(int)(i)].c[(int)(k)] = Element(A, i, k)/s[(int)(k)];
					}
					A.r[(int)(k)].c[(int)(k)] = Element(A, k, k) + 1d;
				}
				s[(int)(k)] = -s[(int)(k)];
			}
			for(j = k + 1d; j < n; j = j + 1d){
				if((k < nct) && (s[(int)(k)] != 0d)){

					/* Apply the transformation.*/
					t = 0d;
					for(i = k; i < m; i = i + 1d){
						t = t + Element(A, i, k)*Element(A, i, j);
					}
					t = -t/Element(A, k, k);
					for(i = k; i < m; i = i + 1d){
						A.r[(int)(i)].c[(int)(j)] = Element(A, i, j) + t*Element(A, i, k);
					}
				}

				/* Place the k-th row of A into e for the subsequent calculation of the row transformation.*/
				e[(int)(j)] = Element(A, k, j);
			}
			if(k < nct){

				/* Place the transformation in U for subsequent back*/
				/* multiplication.*/
				for(i = k; i < m; i = i + 1d){
					U.r[(int)(i)].c[(int)(k)] = Element(A, i, k);
				}
			}
			if(k < nrt){
				/* Compute the k-th row transformation and place the k-th super-diagonal in e[k].*/
				/* Compute 2-norm without under/overflow.*/
				e[(int)(k)] = 0d;
				for(i = k + 1d; i < n; i = i + 1d){
					e[(int)(k)] = Hypothenuse(e[(int)(k)], e[(int)(i)]);
				}
				if(e[(int)(k)] != 0d){
					if(e[(int)(k + 1d)] < 0d){
						e[(int)(k)] = -e[(int)(k)];
					}
					for(i = k + 1d; i < n; i = i + 1d){
						e[(int)(i)] = e[(int)(i)]/e[(int)(k)];
					}
					e[(int)(k + 1d)] = e[(int)(k + 1d)] + 1d;
				}
				e[(int)(k)] = -e[(int)(k)];
				if((k + 1d < m) && (e[(int)(k)] != 0d)){

					/* Apply the transformation.*/
					for(i = k + 1d; i < m; i = i + 1d){
						work[(int)(i)] = 0d;
					}
					for(j = k + 1d; j < n; j = j + 1d){
						for(i = k + 1d; i < m; i = i + 1d){
							work[(int)(i)] = work[(int)(i)] + e[(int)(j)]*Element(A, i, j);
						}
					}
					for(j = k + 1d; j < n; j = j + 1d){
						t = -e[(int)(j)]/e[(int)(k + 1d)];
						for(i = k + 1d; i < m; i = i + 1d){
							A.r[(int)(i)].c[(int)(j)] = Element(A, i, j) + t*work[(int)(i)];
						}
					}
				}

				/* Place the transformation in V for subsequent back multiplication.*/
				for(i = k + 1d; i < n; i = i + 1d){
					V.r[(int)(i)].c[(int)(k)] = e[(int)(i)];
				}
			}
		}

		/* Set up the final bidiagonal matrix or order p.*/
		p = Min(n, m + 1d);
		if(nct < n){
			s[(int)(nct)] = Element(A, nct, nct);
		}
		if(m < p){
			s[(int)(p - 1d)] = 0d;
		}
		if(nrt + 1d < p){
			e[(int)(nrt)] = Element(A, nrt, p - 1d);
		}
		e[(int)(p - 1d)] = 0d;

		/* Generate U.*/
		for(j = nct; j < nu; j = j + 1d){
			for(i = 0d; i < m; i = i + 1d){
				U.r[(int)(i)].c[(int)(j)] = 0d;
			}
			U.r[(int)(j)].c[(int)(j)] = 1d;
		}
		for(k = nct - 1d; k >= 0d; k = k - 1d){
			if(s[(int)(k)] != 0d){
				for(j = k + 1d; j < nu; j = j + 1d){
					t = 0d;
					for(i = k; i < m; i = i + 1d){
						t = t + Element(U, i, k)*Element(U, i, j);
					}
					t = -t/Element(U, k, k);
					for(i = k; i < m; i = i + 1d){
						U.r[(int)(i)].c[(int)(j)] = Element(U, i, j) + t*Element(U, i, k);
					}
				}
				for(i = k; i < m; i = i + 1d){
					U.r[(int)(i)].c[(int)(k)] = -Element(U, i, k);
				}
				U.r[(int)(k)].c[(int)(k)] = 1d + Element(U, k, k);
				for(i = 0d; i < k - 1d; i = i + 1d){
					U.r[(int)(i)].c[(int)(k)] = 0d;
				}
			}else{
				for(i = 0d; i < m; i = i + 1d){
					U.r[(int)(i)].c[(int)(k)] = 0d;
				}
				U.r[(int)(k)].c[(int)(k)] = 1d;
			}
		}

		/* Generate V.*/
		for(k = n - 1d; k >= 0d; k = k - 1d){
			if((k < nrt) && (e[(int)(k)] != 0d)){
				for(j = k + 1d; j < nu; j = j + 1d){
					t = 0d;
					for(i = k + 1d; i < n; i = i + 1d){
						t = t + Element(V, i, k)*Element(V, i, j);
					}
					t = -t/Element(V, k + 1d, k);
					for(i = k + 1d; i < n; i = i + 1d){
						V.r[(int)(i)].c[(int)(j)] = Element(V, i, j) + t*Element(V, i, k);
					}
				}
			}
			for(i = 0d; i < n; i = i + 1d){
				V.r[(int)(i)].c[(int)(k)] = 0d;
			}
			V.r[(int)(k)].c[(int)(k)] = 1d;
		}

		/* Main iteration loop for the singular values.*/
		pp = p - 1d;
		iter = 0d;
		eps = Pow(2d, -52d);
		tiny = Pow(2d, -966d);
		for(; p > 0d; ){
			/* Here is where a test for too many iterations would go.*/
			/* This section of the program inspects for negligible elements in the s and e arrays.*/
			/* On completion the variables kase and k are set as follows.*/
			/* kase = 1, if s(p) and e[k-1] are negligible and k<p*/
			/* kase = 2, if s(k) is negligible and k<p*/
			/* kase = 3, if e[k-1] is negligible, k<p, and s(k), ..., s(p) are not negligible (qr step).*/
			/* kase = 4, if e(p-1) is negligible (convergence).*/
			done = false;
			for(k = p - 2d; k > -1d && !done; ){
				if(Abs(e[(int)(k)]) <= tiny + eps*(Abs(s[(int)(k)]) + Abs(s[(int)(k + 1d)]))){
					e[(int)(k)] = 0d;
					done = true;
				}else{
					k = k - 1d;
				}
			}
			if(k == p - 2d){
				kase = 4d;
			}else{
				done = false;
				for(ks = p - 1d; ks > k && !done; ){
					if(ks != p){
						t = Abs(e[(int)(ks)]);
					}else{
						t = 0d;
					}

					if(ks != k + 1d){
						t = t + Abs(e[(int)(ks - 1d)]);
					}

					if(Abs(s[(int)(ks)]) <= tiny + eps*t){
						s[(int)(ks)] = 0d;
						done = true;
					}else{
						ks = ks - 1d;
					}
				}
				if(ks == k){
					kase = 3d;
				}else if(ks == p - 1d){
					kase = 1d;
				}else{
					kase = 2d;
					k = ks;
				}
			}
			k = k + 1d;

			/* Perform the task indicated by kase.*/
			if(kase == 1d){
				/* Deflate negligible s(p).*/
				f = e[(int)(p - 2d)];
				e[(int)(p - 2d)] = 0d;
				for(j = p - 2d; j >= k; j = j - 1d){
					t = Hypothenuse(s[(int)(j)], f);
					cs = s[(int)(j)]/t;
					sn = f/t;
					s[(int)(j)] = t;
					if(j != k){
						f = -sn*e[(int)(j - 1d)];
						e[(int)(j - 1d)] = cs*e[(int)(j - 1d)];
					}

					for(i = 0d; i < n; i = i + 1d){
						t = cs*Element(V, i, j) + sn*Element(V, i, p - 1d);
						V.r[(int)(i)].c[(int)(p - 1d)] = -sn*Element(V, i, j) + cs*Element(V, i, p - 1d);
						V.r[(int)(i)].c[(int)(j)] = t;
					}
				}
			}else if(kase == 2d){
				/* Split at negligible s(k).*/
				f = e[(int)(k - 1d)];
				e[(int)(k - 1d)] = 0d;
				for(j = k; j < p; j = j + 1d){
					t = Hypothenuse(s[(int)(j)], f);
					cs = s[(int)(j)]/t;
					sn = f/t;
					s[(int)(j)] = t;
					f = -sn*e[(int)(j)];
					e[(int)(j)] = cs*e[(int)(j)];

					for(i = 0d; i < m; i = i + 1d){
						t = cs*Element(U, i, j) + sn*Element(U, i, k + 1d);
						U.r[(int)(i)].c[(int)(k - 1d)] = -sn*Element(U, i, j) + cs*Element(U, i, k + 1d);
						U.r[(int)(i)].c[(int)(j)] = t;
					}
				}
			}else if(kase == 3d){
				/* Perform one qr step.*/
				/* Calculate the shift.*/
				scale = Max(Max(Max(Max(Abs(s[(int)(p - 1d)]), Abs(s[(int)(p - 2d)])), Abs(e[(int)(p - 2d)])), Abs(s[(int)(k)])), Abs(e[(int)(k)]));
				sp = s[(int)(p - 1d)]/scale;
				spm1 = s[(int)(p - 2d)]/scale;
				epm1 = e[(int)(p - 2d)]/scale;
				sk = s[(int)(k)]/scale;
				ek = e[(int)(k)]/scale;
				b = ((spm1 + sp)*(spm1 - sp) + epm1*epm1)/2d;
				c = (sp*epm1)*(sp*epm1);
				shift = 0d;
				if((b != 0d) || (c != 0d)){
					shift = Sqrt(b*b + c);
					if(b < 0d){
						shift = -shift;
					}
					shift = c/(b + shift);
				}
				f = (sk + sp)*(sk - sp) + shift;
				g = sk*ek;

				/* Chase zeros.*/
				for(j = k; j < p - 1d; j = j + 1d){
					t = Hypothenuse(f, g);
					cs = f/t;
					sn = g/t;
					if(j != k){
						e[(int)(j - 1d)] = t;
					}
					f = cs*s[(int)(j)] + sn*e[(int)(j)];
					e[(int)(j)] = cs*e[(int)(j)] - sn*s[(int)(j)];
					g = sn*s[(int)(j + 1d)];
					s[(int)(j + 1d)] = cs*s[(int)(j + 1d)];
					for(i = 0d; i < n; i = i + 1d){
						t = cs*Element(V, i, j) + sn*Element(V, i, j + 1d);
						V.r[(int)(i)].c[(int)(j + 1d)] = -sn*Element(V, i, j) + cs*Element(V, i, j + 1d);
						V.r[(int)(i)].c[(int)(j)] = t;
					}
					t = Hypothenuse(f, g);
					cs = f/t;
					sn = g/t;
					s[(int)(j)] = t;
					f = cs*e[(int)(j)] + sn*s[(int)(j + 1d)];
					s[(int)(j + 1d)] = -sn*e[(int)(j)] + cs*s[(int)(j + 1d)];
					g = sn*e[(int)(j + 1d)];
					e[(int)(j + 1d)] = cs*e[(int)(j + 1d)];
					if(j < m - 1d){
						for(i = 0d; i < m; i = i + 1d){
							t = cs*Element(U, i, j) + sn*Element(U, i, j + 1d);
							U.r[(int)(i)].c[(int)(j + 1d)] = -sn*Element(U, i, j) + cs*Element(U, i, j + 1d);
							U.r[(int)(i)].c[(int)(j)] = t;
						}
					}
				}
				e[(int)(p - 2d)] = f;
				iter = iter + 1d;
			}else if(kase == 4d){
				/* Make the singular values positive.*/
				if(s[(int)(k)] <= 0d){
					if(s[(int)(k)] < 0d){
						s[(int)(k)] = -s[(int)(k)];
					}else{
						s[(int)(k)] = 0d;
					}

					for(i = 0d; i <= pp; i = i + 1d){
						V.r[(int)(i)].c[(int)(k)] = -Element(V, i, k);
					}
				}

				/* Order the singular values.*/
				for(; k < pp && s[(int)(k)] < s[(int)(k + 1d)]; ){
					t = s[(int)(k)];
					s[(int)(k)] = s[(int)(k + 1d)];
					s[(int)(k + 1d)] = t;
					if(k < n - 1d){
						for(i = 0d; i < n; i = i + 1d){
							t = Element(V, i, k + 1d);
							V.r[(int)(i)].c[(int)(k + 1d)] = Element(V, i, k);
							V.r[(int)(i)].c[(int)(k)] = t;
						}
					}
					if(k < m - 1d){
						for(i = 0d; i < m; i = i + 1d){
							t = Element(U, i, k + 1d);
							U.r[(int)(i)].c[(int)(k + 1d)] = Element(U, i, k);
							U.r[(int)(i)].c[(int)(k)] = t;
						}
					}
					k = k + 1d;
				}
				iter = 0d;
				p = p - 1d;
			}
		}

		Resize(U, orgm, orgm);
		Resize(V, orgn, orgn);

		URef.matrix = U;
		VRef.matrix = V;
		SigmaRef.matrix = CreateMatrix(orgm, orgn);
		for(i = 0d; i < Min(orgm, orgn); i = i + 1d){
			SigmaRef.matrix.r[(int)(i)].c[(int)(i)] = s[(int)(i)];
		}

		return true;
	}


	public static ComplexMatrix CreateComplexMatrix(double rows, double cols){
		double m, n;
		ComplexMatrix matrix;

		matrix = new ComplexMatrix();
		matrix.r = new ComplexMatrixRow [(int)(rows)];
		for(m = 0d; m < rows; m = m + 1d){
			matrix.r[(int)(m)] = new ComplexMatrixRow();
			matrix.r[(int)(m)].c = new cComplexNumber [(int)(cols)];
			for(n = 0d; n < cols; n = n + 1d){
				matrix.r[(int)(m)].c[(int)(n)] = cCreateComplexNumber(0d, 0d);
			}
		}

		return matrix;
	}


	public static ComplexMatrix CreateComplexMatrixFromMatrix(Matrix a){
		double m, n, rows, cols;
		ComplexMatrix matrix;

		rows = NumberOfRows(a);
		cols = NumberOfColumns(a);

		matrix = new ComplexMatrix();
		matrix.r = new ComplexMatrixRow [(int)(rows)];
		for(m = 0d; m < rows; m = m + 1d){
			matrix.r[(int)(m)] = new ComplexMatrixRow();
			matrix.r[(int)(m)].c = new cComplexNumber [(int)(cols)];
			for(n = 0d; n < cols; n = n + 1d){
				matrix.r[(int)(m)].c[(int)(n)] = cCreateComplexNumber(a.r[(int)(m)].c[(int)(n)], 0d);
			}
		}

		return matrix;
	}


	public static Matrix CreateReMatrixFromComplexMatrix(ComplexMatrix a){
		double m, n, rows, cols;
		Matrix matrix;

		rows = NumberOfRowsComplex(a);
		cols = NumberOfColumnsComplex(a);

		matrix = new Matrix();
		matrix.r = new MatrixRow [(int)(rows)];
		for(m = 0d; m < rows; m = m + 1d){
			matrix.r[(int)(m)] = new MatrixRow();
			matrix.r[(int)(m)].c = new double [(int)(cols)];
			for(n = 0d; n < cols; n = n + 1d){
				matrix.r[(int)(m)].c[(int)(n)] = IndexComplex(a, m, n).re;
			}
		}

		return matrix;
	}


	public static Matrix CreateImMatrixFromComplexMatrix(ComplexMatrix a){
		double m, n, rows, cols;
		Matrix matrix;

		rows = NumberOfRowsComplex(a);
		cols = NumberOfColumnsComplex(a);

		matrix = new Matrix();
		matrix.r = new MatrixRow [(int)(rows)];
		for(m = 0d; m < rows; m = m + 1d){
			matrix.r[(int)(m)] = new MatrixRow();
			matrix.r[(int)(m)].c = new double [(int)(cols)];
			for(n = 0d; n < cols; n = n + 1d){
				matrix.r[(int)(m)].c[(int)(n)] = IndexComplex(a, m, n).im;
			}
		}

		return matrix;
	}


	public static double NumberOfRowsComplex(ComplexMatrix A){
		return A.r.Length;
	}


	public static double NumberOfColumnsComplex(ComplexMatrix A){
		return A.r[0].c.Length;
	}


	public static cComplexNumber IndexComplex(ComplexMatrix a, double m, double n){
		return a.r[(int)(m)].c[(int)(n)];
	}


	public static void AddComplex(ComplexMatrix a, ComplexMatrix b){
		double m, n;
		double d;

		d = NumberOfRowsComplex(a);

		for(m = 0d; m < d; m = m + 1d){
			for(n = 0d; n < d; n = n + 1d){
				cAdd(IndexComplex(a, m, n), IndexComplex(b, m, n));
			}
		}
	}


	public static void SubtractComplex(ComplexMatrix a, ComplexMatrix b){
		double m, n;
		double r, c;

		r = NumberOfRowsComplex(a);
		c = NumberOfColumnsComplex(a);

		for(m = 0d; m < r; m = m + 1d){
			for(n = 0d; n < c; n = n + 1d){
				cSub(IndexComplex(a, m, n), IndexComplex(b, m, n));
			}
		}
	}


	public static ComplexMatrix SubtractComplexToNew(ComplexMatrix a, ComplexMatrix b){
		ComplexMatrix X;

		X = CreateCopyOfComplexMatrix(a);
		SubtractComplex(X, b);

		return X;
	}


	public static void MultiplyComplex(ComplexMatrix x, ComplexMatrix a, ComplexMatrix b){
		double m, n;
		double rows, cols, d;
		double i;
		cComplexNumber s, t;

		rows = NumberOfRowsComplex(a);
		cols = NumberOfColumnsComplex(b);
		d = NumberOfColumnsComplex(a);
		t = cCreateComplexNumber(0d, 0d);

		for(m = 0d; m < rows; m = m + 1d){
			for(n = 0d; n < cols; n = n + 1d){
				s = cCreateComplexNumber(0d, 0d);

				for(i = 0d; i < d; i = i + 1d){
					cAssignComplex(t, s);
					cAssignComplex(s, IndexComplex(a, m, i));
					cMul(s, IndexComplex(b, i, n));
					cAdd(s, t);
				}

				x.r[(int)(m)].c[(int)(n)] = s;
			}
		}
	}


	public static ComplexMatrix MultiplyComplexToNew(ComplexMatrix a, ComplexMatrix b){
		double rows, cols;
		ComplexMatrix x;

		rows = NumberOfRowsComplex(a);
		cols = NumberOfColumnsComplex(b);
		x = CreateComplexMatrix(rows, cols);
		MultiplyComplex(x, a, b);

		return x;
	}


	public static void Conjugate(ComplexMatrix a){
		double m, n;
		double rows, cols;

		rows = NumberOfRowsComplex(a);
		cols = NumberOfRowsComplex(a);

		for(m = 0d; m < rows; m = m + 1d){
			for(n = 0d; n < cols; n = n + 1d){
				cConjugate(IndexComplex(a, m, n));
			}
		}
	}


	public static void AssignComplexMatrix(ComplexMatrix A, ComplexMatrix B){
		double m, n;
		double r, c;

		r = NumberOfRowsComplex(A);
		c = NumberOfColumnsComplex(A);

		for(m = 0d; m < r; m = m + 1d){
			for(n = 0d; n < c; n = n + 1d){
				cAssignComplex(IndexComplex(A, m, n), IndexComplex(B, m, n));
			}
		}
	}


	public static void ScalarMultiplyComplex(ComplexMatrix A, cComplexNumber b){
		double m, n;
		double r, c;

		r = NumberOfRowsComplex(A);
		c = NumberOfColumnsComplex(A);

		for(m = 0d; m < r; m = m + 1d){
			for(n = 0d; n < c; n = n + 1d){
				cMul(IndexComplex(A, m, n), b);
			}
		}
	}


	public static ComplexMatrix ScalarMultiplyComplexToNew(ComplexMatrix A, cComplexNumber b){
		ComplexMatrix matrix;

		matrix = CreateCopyOfComplexMatrix(A);
		ScalarMultiplyComplex(matrix, b);

		return matrix;
	}


	public static void ScalarDivideComplex(ComplexMatrix A, cComplexNumber b){
		double m, n;
		double r, c;

		r = NumberOfRowsComplex(A);
		c = NumberOfColumnsComplex(A);

		for(m = 0d; m < r; m = m + 1d){
			for(n = 0d; n < c; n = n + 1d){
				cDiv(IndexComplex(A, m, n), b);
			}
		}
	}


	public static void ElementWisePowerComplex(ComplexMatrix A, double p){
		double m, n;
		double r, c;

		r = NumberOfRowsComplex(A);
		c = NumberOfColumnsComplex(A);

		for(m = 0d; m < r; m = m + 1d){
			for(n = 0d; n < c; n = n + 1d){
				cPower(IndexComplex(A, m, n), p);
			}
		}
	}


	public static ComplexMatrix CreateComplexIdentityMatrix(double d){
		double m;
		ComplexMatrix matrix;

		matrix = CreateSquareComplexMatrix(d);
		FillComplex(matrix, 0d, 0d);

		for(m = 0d; m < d; m = m + 1d){
			IndexComplex(matrix, m, m).re = 1d;
		}

		return matrix;
	}


	public static ComplexMatrix CreateSquareComplexMatrix(double d){
		double m, n;
		ComplexMatrix matrix;

		matrix = new ComplexMatrix();
		matrix.r = new ComplexMatrixRow [(int)(d)];
		for(m = 0d; m < d; m = m + 1d){
			matrix.r[(int)(m)] = new ComplexMatrixRow();
			matrix.r[(int)(m)].c = new cComplexNumber [(int)(d)];
			for(n = 0d; n < d; n = n + 1d){
				matrix.r[(int)(m)].c[(int)(n)] = cCreateComplexNumber(0d, 0d);
			}
		}

		return matrix;
	}


	public static void ClearComplex(ComplexMatrix a){
		FillComplex(a, 0d, 0d);
	}


	public static void FillComplex(ComplexMatrix a, double re, double im){
		double m, n;

		for(m = 0d; m < NumberOfRowsComplex(a); m = m + 1d){
			for(n = 0d; n < NumberOfColumnsComplex(a); n = n + 1d){
				IndexComplex(a, m, n).re = re;
				IndexComplex(a, m, n).im = im;
			}
		}
	}


	public static cComplexNumber TraceComplex(ComplexMatrix a){
		double m;
		double d;
		cComplexNumber tr;

		tr = cCreateComplexNumber(0d, 0d);

		d = a.r.Length;
		for(m = 0d; m < d; m = m + 1d){
			cAdd(tr, IndexComplex(a, m, m));
		}

		return tr;
	}


	public static void CofactorOfComplexMatrix(ComplexMatrix mat, ComplexMatrix temp, double p, double q, double n){
		double i, j;
		double row, col;

		i = 0d;
		j = 0d;

		for(row = 0d; row < n; row = row + 1d){
			for(col = 0d; col < n; col = col + 1d){
				if(row != p && col != q){
					cAssignComplex(IndexComplex(temp, i, j), IndexComplex(mat, row, col));
					j = j + 1d;

					if(j == n - 1d){
						j = 0d;
						i = i + 1d;
					}
				}
			}
		}
	}


	public static cComplexNumber DeterminantOfComplexSubmatrix(ComplexMatrix mat, double n){
		double f, sign;
		cComplexNumber D, t;
		ComplexMatrix temp;

		D = cCreateComplexNumber(0d, 0d);
		t = cCreateComplexNumber(0d, 0d);

		if(n == 1d){
			D = mat.r[0].c[0];
		}else{
			temp = CreateSquareComplexMatrix(n);

			sign = 1d;

			for(f = 0d; f < n; f = f + 1d){
				CofactorOfComplexMatrix(mat, temp, 0d, f, n);
				cAssignComplexByValues(t, sign, 0d);
				cMul(t, IndexComplex(mat, 0d, f));
				cMul(t, DeterminantOfComplexSubmatrix(temp, n - 1d));
				cAdd(D, t);
				sign = -sign;
			}

			DeleteComplexMatrix(temp);
		}

		return D;
	}


	public static void DeleteComplexMatrix(ComplexMatrix X){
		double m, n, rows, cols;

		rows = NumberOfRowsComplex(X);
		cols = NumberOfColumnsComplex(X);
		for(m = 0d; m < rows; m = m + 1d){
			for(n = 0d; n < cols; n = n + 1d){
				delete(X.r[(int)(m)].c[(int)(n)]);
			}
			delete(X.r[(int)(m)].c);
			delete(X.r[(int)(m)]);
		}

		delete(X.r);
		delete(X);
	}


	public static cComplexNumber DeterminantComplex(ComplexMatrix m){
		double n;
		cComplexNumber D;

		n = NumberOfRowsComplex(m);
		D = DeterminantOfComplexSubmatrix(m, n);

		return D;
	}


	public static void AdjointComplex(ComplexMatrix A, ComplexMatrix adj){
		double n;
		ComplexMatrix cofactors;
		double i, j;
		cComplexNumber t, sign;

		n = A.r.Length;
		t = cCreateComplexNumber(0d, 0d);
		sign = cCreateComplexNumber(0d, 0d);

		if(n == 1d){
			cAssignComplexByValues(IndexComplex(adj, 0d, 0d), 1d, 0d);
		}else{
			cofactors = CreateSquareComplexMatrix(n);

			for(i = 0d; i < n; i = i + 1d){
				for(j = 0d; j < n; j = j + 1d){
					CofactorOfComplexMatrix(A, cofactors, i, j, n);

					if((i + j)%2d == 0d){
						cAssignComplexByValues(sign, 1d, 0d);
					}else{
						cAssignComplexByValues(sign, -1d, 0d);
					}

					cAssignComplex(t, sign);
					cMul(t, DeterminantOfComplexSubmatrix(cofactors, n - 1d));
					cAssignComplex(IndexComplex(adj, j, i), t);
				}
			}

			DeleteComplexMatrix(cofactors);
		}
	}


	public static bool InverseComplex(ComplexMatrix A, ComplexMatrix inverseResult){
		bool success;
		ComplexMatrix adj;
		double n, i, j;
		cComplexNumber det, t;

		t = cCreateComplexNumber(0d, 0d);

		if(NumberOfColumnsComplex(A) == NumberOfRowsComplex(A)){
			n = NumberOfColumnsComplex(A);

			det = DeterminantComplex(A);
			if(det.re != 0d || det.im != 0d){
				adj = CreateSquareComplexMatrix(n);
				AdjointComplex(A, adj);

				for(i = 0d; i < n; i = i + 1d){
					for(j = 0d; j < n; j = j + 1d){
						cAssignComplex(t, IndexComplex(adj, i, j));
						cDiv(t, det);
						cAssignComplex(IndexComplex(inverseResult, i, j), t);
					}
				}

				success = true;
				DeleteComplexMatrix(adj);
			}else{
				success = false;
			}
		}else{
			success = false;
		}

		return success;
	}


	public static bool ComplexMatrixEqualsEpsilon(ComplexMatrix b, ComplexMatrix f, double epsilon){
		double x, y, columns, rows;
		bool equals;

		equals = true;

		if(NumberOfRowsComplex(b) == NumberOfRowsComplex(f) && NumberOfColumnsComplex(b) == NumberOfColumnsComplex(f)){
			columns = NumberOfColumnsComplex(b);
			rows = NumberOfRowsComplex(b);

			for(x = 0d; x < rows; x = x + 1d){
				for(y = 0d; y < columns; y = y + 1d){
					equals = equals && cEpsilonCompareComplex(IndexComplex(b, x, y), IndexComplex(f, x, y), epsilon);
				}
			}
		}else{
			equals = false;
		}

		return equals;
	}


	public static ComplexMatrix MinorComplex(ComplexMatrix x, double row, double column){
		ComplexMatrix minor;
		double cols, rows, i, j, m, n;

		rows = NumberOfRowsComplex(x) - 1d;
		cols = NumberOfColumnsComplex(x) - 1d;

		minor = CreateComplexMatrix(rows, cols);

		for(i = 0d; i < rows; i = i + 1d){
			if(i < row){
				m = i;
			}else{
				m = i + 1d;
			}

			for(j = 0d; i != row && j < cols; j = j + 1d){
				if(j != column){

					if(j < column){
						n = j;
					}else{
						n = j + 1d;
					}

					cAssignComplex(IndexComplex(minor, m, n), IndexComplex(x, i, j));
				}
			}
		}

		return minor;
	}


	public static void AssignComplex(ComplexMatrix A, ComplexMatrix B){
		double m, n;
		double r, c;

		r = NumberOfRowsComplex(A);
		c = NumberOfColumnsComplex(A);
		for(m = 0d; m < r; m = m + 1d){
			for(n = 0d; n < c; n = n + 1d){
				cAssignComplex(IndexComplex(A, m, n), IndexComplex(B, m, n));
			}
		}
	}


	public static ComplexMatrix CreateCopyOfComplexMatrix(ComplexMatrix A){
		ComplexMatrix X;

		X = CreateComplexMatrix(NumberOfRowsComplex(A), NumberOfColumnsComplex(A));
		AssignComplex(X, A);

		return X;
	}


	public static bool TransposeComplex(ComplexMatrix a){
		double m, n;
		double rows;
		bool square;
		cComplexNumber tmp;

		tmp = cCreateComplexNumber(0d, 0d);

		square = IsSquareComplexMatrix(a);
		if(square){
			rows = NumberOfColumnsComplex(a);

			for(m = 0d; m < rows; m = m + 1d){
				for(n = 0d; n < m; n = n + 1d){
					cAssignComplex(tmp, IndexComplex(a, n, m));
					cAssignComplex(IndexComplex(a, n, m), IndexComplex(a, m, n));
					cAssignComplex(IndexComplex(a, m, n), tmp);
				}
			}
		}

		return square;
	}


	public static bool ConjugateTransposeComplex(ComplexMatrix a){
		double m, n;
		double rows;
		bool square;
		cComplexNumber tmp;

		tmp = cCreateComplexNumber(0d, 0d);

		square = IsSquareComplexMatrix(a);
		if(square){
			rows = NumberOfColumnsComplex(a);

			for(m = 0d; m < rows; m = m + 1d){
				for(n = 0d; n < m; n = n + 1d){
					cAssignComplex(tmp, IndexComplex(a, n, m));
					cAssignComplex(IndexComplex(a, n, m), IndexComplex(a, m, n));
					cAssignComplex(IndexComplex(a, m, n), tmp);
					cConjugate(IndexComplex(a, m, n));
				}
			}
		}

		return square;
	}


	public static bool IsSquareComplexMatrix(ComplexMatrix A){
		bool isx;

		if(NumberOfRowsComplex(A) == NumberOfColumnsComplex(A)){
			isx = true;
		}else{
			isx = false;
		}

		return isx;
	}


	public static void TransposeComplexAssign(ComplexMatrix t, ComplexMatrix a){
		double m, n;
		double rows, cols;

		cols = NumberOfRowsComplex(a);
		rows = NumberOfColumnsComplex(a);

		for(m = 0d; m < cols; m = m + 1d){
			for(n = 0d; n < rows; n = n + 1d){
				cAssignComplex(IndexComplex(t, n, m), IndexComplex(a, m, n));
			}
		}
	}


	public static ComplexMatrix TransposeComplexToNew(ComplexMatrix a){
		double m, n;
		double rows, cols;
		ComplexMatrix c;

		cols = NumberOfRowsComplex(a);
		rows = NumberOfColumnsComplex(a);

		c = CreateComplexMatrix(rows, cols);

		for(m = 0d; m < cols; m = m + 1d){
			for(n = 0d; n < rows; n = n + 1d){
				cAssignComplex(IndexComplex(c, n, m), IndexComplex(a, m, n));
			}
		}

		return c;
	}


	public static ComplexMatrix ExtractComplexSubMatrix(ComplexMatrix M, double r1, double r2, double c1, double c2){
		ComplexMatrix A;
		double i, j;

		A = CreateComplexMatrix(r2 - r1 + 1d, c2 - c1 + 1d);

		for(i = r1; i <= r2; i = i + 1d){
			for(j = c1; j <= c2; j = j + 1d){
				cAssignComplex(IndexComplex(A, i - r1, j - c1), IndexComplex(M, i, j));
			}
		}

		return A;
	}


	public static double NormComplex(ComplexMatrix a){
		double l, i, j, rows, cols;
		cComplexNumber cComplexNumber;

		l = 0d;

		rows = NumberOfRowsComplex(a);
		cols = NumberOfColumnsComplex(a);

		for(i = 0d; i < rows; i = i + 1d){
			for(j = 0d; j < cols; j = j + 1d){
				cComplexNumber = IndexComplex(a, i, j);
				l = l + Pow(cComplexNumber.re, 2d) + Pow(cComplexNumber.im, 2d);
			}
		}
		l = Sqrt(l);

		return l;
	}


	public static void ComplexCharacteristicPolynomial(ComplexMatrix A, pComplexPolynomial p){
		ComplexMatrix cp;
		cComplexNumber determinant;

		cp = CreateSquareComplexMatrix(NumberOfRowsComplex(A));
		determinant = new cComplexNumber();

		ComplexCharacteristicPolynomialWithInverse(A, cp, p, determinant);

		DeleteComplexMatrix(cp);
	}


	public static void ComplexCharacteristicPolynomialWithInverse(ComplexMatrix A, ComplexMatrix AInverse, pComplexPolynomial p, cComplexNumber determinant){
		FaddeevLeVerrierAlgorithmComplex(A, AInverse, p, determinant);
	}


	public static void FaddeevLeVerrierAlgorithmComplex(ComplexMatrix A, ComplexMatrix AInverse, pComplexPolynomial p, cComplexNumber determinant){
		ComplexMatrix Mk, Mkm1, t1, Id;
		cComplexNumber t, t2, n1;
		double i, n, k;

		n1 = cCreateComplexNumber(-1d, 0d);
		n = NumberOfRowsComplex(A);
		p.cs = new cComplexNumber [(int)(n + 1d)];
		for(i = 0d; i < n + 1d; i = i + 1d){
			p.cs[(int)(i)] = new cComplexNumber();
		}
		cAssignComplexByValues(p.cs[(int)(n)], 1d, 0d);
		Mkm1 = CreateSquareComplexMatrix(n);
		FillComplex(Mkm1, 0d, 0d);
		Id = CreateComplexIdentityMatrix(n);
		Mk = CreateSquareComplexMatrix(n);
		t1 = CreateSquareComplexMatrix(n);

		for(k = 1d; k <= n; k = k + 1d){
			MultiplyComplex(Mk, A, Mkm1);
			AssignComplex(t1, Id);
			ScalarMultiplyComplex(t1, p.cs[(int)(n - k + 1d)]);
			AddComplex(Mk, t1);

			MultiplyComplex(t1, A, Mk);
			t = TraceComplex(t1);
			t2 = cCreateComplexNumber(-1d/k, 0d);
			cMul(t, t2);
			cAssignComplex(p.cs[(int)(n - k)], t);

			/* done*/
			AssignComplex(Mkm1, Mk);

			if(k == n){
				AssignComplex(AInverse, Mk);
				cAssignComplex(t, p.cs[0]);
				cMul(t, n1);
				cAssignComplex(determinant, t);
				if(t.re == 0d && t.im == 0d){
				}else{
					ScalarDivideComplex(AInverse, t);
				}
			}
		}

		DeleteComplexMatrix(Mkm1);
		DeleteComplexMatrix(Id);
		DeleteComplexMatrix(Mk);
		DeleteComplexMatrix(t1);
	}


	public static bool EigenvaluesComplex(ComplexMatrix A, cComplexNumberArrayReference eigenValuesReference){
		ComplexMatrixArrayReference eigenVectorsReference;
		bool success;
		double i;

		eigenVectorsReference = new ComplexMatrixArrayReference();
		success = EigenpairsComplex(A, eigenValuesReference, eigenVectorsReference);
		if(success){
			for(i = 0d; i < eigenVectorsReference.matrices.Length; i = i + 1d){
				DeleteComplexMatrix(eigenVectorsReference.matrices[(int)(i)]);
			}
			delete(eigenVectorsReference.matrices);
			delete(eigenVectorsReference);
		}

		return success;
	}


	public static bool EigenvectorsComplex(ComplexMatrix A, ComplexMatrixArrayReference eigenVectorsReference){
		cComplexNumberArrayReference evsReference;
		bool success;
		double i;

		evsReference = new cComplexNumberArrayReference();
		success = EigenpairsComplex(A, evsReference, eigenVectorsReference);
		if(success){
			for(i = 0d; i < evsReference.complexNumbers.Length; i = i + 1d){
				delete(evsReference.complexNumbers[(int)(i)]);
			}
			delete(evsReference.complexNumbers);
			delete(evsReference);
		}

		return success;
	}


	public static bool InversePowerMethodComplex(ComplexMatrix A, cComplexNumber eigenvalue, double maxIterations, cComplexNumberArrayReference eigenvector){
		ComplexMatrix t1, t2, t3, t4, b;
		double n, i, c;
		bool isSingular;
		cComplexNumber c101, k, cc;

		n = NumberOfRowsComplex(A);

		t2 = CreateComplexIdentityMatrix(n);
		ScalarMultiplyComplex(t2, eigenvalue);
		t3 = SubtractComplexToNew(A, t2);
		t4 = CreateSquareComplexMatrix(n);
		isSingular = !InverseComplex(t3, t4);
		cc = cCreateComplexNumber(0d, 0d);
		t1 = CreateComplexMatrix(n, 1d);

		if(isSingular){
			DeleteComplexMatrix(t2);
			DeleteComplexMatrix(t3);
			DeleteComplexMatrix(t4);

			c101 = cCreateComplexNumber(1.01, 0d);
			/* Try again with more erroneous eigenvalue estimate.*/
			t2 = CreateComplexIdentityMatrix(n);
			k = cMulToNew(eigenvalue, c101);
			ScalarMultiplyComplex(t2, k);
			t3 = SubtractComplexToNew(A, t2);
			t4 = CreateSquareComplexMatrix(n);
			isSingular = !InverseComplex(t3, t4);
			delete(c101);
		}

		if(!isSingular){
			b = CreateComplexMatrix(n, 1d);

			for(i = 0d; i < n; i = i + 1d){
				cAssignComplexByValues(b.r[(int)(i)].c[0], 1d, 1d);
			}

			for(i = 0d; i < maxIterations; i = i + 1d){
				MultiplyComplex(t1, t4, b);
				c = NormComplex(t1);
				cAssignComplexByValues(cc, c, 0d);
				ScalarDivideComplex(t1, cc);
				AssignComplex(b, t1);
			}

			eigenvector.complexNumbers = new cComplexNumber [(int)(n)];
			for(i = 0d; i < n; i = i + 1d){
				eigenvector.complexNumbers[(int)(i)] = b.r[(int)(i)].c[0];
			}
		}

		DeleteComplexMatrix(t1);
		DeleteComplexMatrix(t2);
		DeleteComplexMatrix(t3);
		DeleteComplexMatrix(t4);
		delete(cc);

		return !isSingular;
	}


	public static bool EigenpairsComplex(ComplexMatrix M, cComplexNumberArrayReference eigenValuesReference, ComplexMatrixArrayReference eigenVectorsReference){
		return ComplexEigenpairsUsingDurandKernerAndInversePowerMethod(M, eigenValuesReference, eigenVectorsReference, 0.000001, 100d);
	}


	public static bool ComplexEigenpairsUsingDurandKernerAndInversePowerMethod(ComplexMatrix M, cComplexNumberArrayReference eigenValuesReference, ComplexMatrixArrayReference eigenVectorsReference, double precision, double maxIterations){
		bool success, inverseSuccess;
		double n, i, j, k, withinPrecision;
		cComplexNumber t1, t2, t3, xn1, eigenValue;
		cComplexNumber [] rs, rsPrev;
		pComplexPolynomial p;
		cComplexNumberArrayReference evecReference;
		ComplexMatrix eigenVector;

		evecReference = new cComplexNumberArrayReference();

		p = new pComplexPolynomial();
		ComplexCharacteristicPolynomial(M, p);

		n = p.cs.Length - 1d;
		rs = new cComplexNumber [(int)(n)];
		for(i = 0d; i < n; i = i + 1d){
			rs[(int)(i)] = cCreateComplexNumber(0d, 0d);
		}
		rsPrev = new cComplexNumber [(int)(n)];
		for(i = 0d; i < n; i = i + 1d){
			rsPrev[(int)(i)] = cCreateComplexNumber(0.4, 0.9);
			cPower(rsPrev[(int)(i)], i);
		}
		t2 = cCreateComplexNumber(0d, 0d);
		t3 = cCreateComplexNumber(0d, 0d);

		success = false;

		eigenVectorsReference.matrices = new ComplexMatrix [(int)(n)];
		for(i = 0d; i < n; i = i + 1d){
			eigenVectorsReference.matrices[(int)(i)] = CreateComplexMatrix(n, 1d);
		}

		for(i = 0d; i < maxIterations && !success; i = i + 1d){
			for(j = 0d; j < n; j = j + 1d){
				xn1 = rsPrev[(int)(j)];

				t1 = pEvaluateComplex(p, xn1);
				cAssignComplexByValues(t2, 1d, 0d);
				for(k = 0d; k < n; k = k + 1d){
					if(k < j){
						cAssignComplex(t3, xn1);
						cSub(t3, rs[(int)(k)]);
						cMul(t2, t3);
					}
					if(k > j){
						cAssignComplex(t3, xn1);
						cSub(t3, rsPrev[(int)(k)]);
						cMul(t2, t3);
					}
				}
				cDiv(t1, t2);
				cAssignComplex(rs[(int)(j)], xn1);
				cSub(rs[(int)(j)], t1);

				delete(t1);
			}
			withinPrecision = 0d;
			for(j = 0d; j < n; j = j + 1d){
				eigenValue = rs[(int)(j)];

				/* Calculate the eigenvector corresponding to the eigenvalue.*/
				inverseSuccess = InversePowerMethodComplex(M, eigenValue, i + 1d, evecReference);
				if(inverseSuccess){
					for(k = 0d; k < n; k = k + 1d){
						eigenVectorsReference.matrices[(int)(j)].r[(int)(k)].c[0] = evecReference.complexNumbers[(int)(k)];
					}

					/* Check eigenpair agains precision.*/
					eigenVector = eigenVectorsReference.matrices[(int)(j)];

					if(CheckComplexEigenpairPrecision(M, eigenValue, eigenVector, precision)){
						withinPrecision = withinPrecision + 1d;
					}
					cAssignComplex(rsPrev[(int)(j)], rs[(int)(j)]);
				}
			}
			if(withinPrecision == n){
				success = true;
			}
		}

		eigenValuesReference.complexNumbers = rs;

		return success;
	}


	public static bool CheckComplexEigenpairPrecision(ComplexMatrix a, cComplexNumber lambda, ComplexMatrix e, double precision){
		ComplexMatrix vec1, vec2;
		bool equal;

		vec1 = MultiplyComplexToNew(a, e);
		vec2 = ScalarMultiplyComplexToNew(e, lambda);

		equal = ComplexMatrixEqualsEpsilon(vec1, vec2, precision);

		return equal;
	}


	public static bool FindRoots(double [] p, NumberArrayReference rootsReference){
		return DurandKernerMethod(p, 0.000001, 100d, rootsReference);
	}


	public static bool LaguerresMethodWithRepeatedDivision(double [] p, double maxIterations, double precision, double guess, NumberArrayReference rootsReference){
		double n, nr, xk;
		double [] x;
		double [] q, r, d;
		bool success;
		NumberReference xkReference;

		n = pDegree(p);

		x = new double [(int)(n)];

		q = pCreatePolynomial(n);
		r = pCreatePolynomial(n);
		d = pCreatePolynomial(n);

		success = true;
		xkReference = CreateNumberReference(0d);

		for(nr = 0d; nr < n && success; nr = nr + 1d){
			success = LaguerresMethod(p, guess, maxIterations, precision, xkReference);

			if(success){
				xk = xkReference.numberValue;
				x[(int)(nr)] = xk;

				pFill(d, 0d);
				d[0] = -xk;
				d[1] = 1d;
				pDivide(q, r, p, d);
				pAssign(p, q);
			}
		}

		delete(q);
		delete(r);
		delete(d);
        
		rootsReference.numberArray = x;

		return success;
	}


	public static bool LaguerresMethod(double [] p, double guess, double maxIterations, double precision, NumberReference rootReference){
		double k, a, G, H, xk, denom1, denom2, denom, t1, n;
		bool success;

		n = pDegree(p);
		success = true;

		xk = guess;

		for(k = 0d; (k < maxIterations) && (Abs(pEvaluate(p, xk)) >= precision) && success; k = k + 1d){
			G = pEvaluateDerivative(p, xk, 1d)/pEvaluate(p, xk);
			H = Pow(G, 2d) - pEvaluateDerivative(p, xk, 2d)/pEvaluate(p, xk);
			t1 = (n - 1d)*(n*H - Pow(G, 2d));
			if(t1 >= 0d){
				denom = Sqrt(t1);
				denom1 = G + denom;
				denom2 = G - denom;
				if(Abs(denom1) >= Abs(denom2)){
					denom = denom1;
				}else{
					denom = denom2;
				}
				a = n/denom;

				xk = xk - a;
			}else{
				success = false;
			}
		}

		if(k == maxIterations){
			success = false;
		}

		if(Abs(pEvaluate(p, xk)) >= precision){
			success = false;
		}

		rootReference.numberValue = xk;

		return success;
	}


	public static bool DurandKernerMethod(double [] p, double precision, double maxIterations, NumberArrayReference rootsReference){
		bool success;
		double n, i, j, k, t1, t2, xn1, withinPrecision;
		double [] rs, rsPrev;

		n = p.Length - 1d;
		rs = new double [(int)(n)];
		rsPrev = new double [(int)(n)];

		for(i = 0d; i < n; i = i + 1d){
			rsPrev[(int)(i)] = i;
		}

		success = false;

		for(i = 0d; i < maxIterations && !success; i = i + 1d){
			for(j = 0d; j < n; j = j + 1d){
				xn1 = rsPrev[(int)(j)];

				t1 = pEvaluate(p, xn1);
				t2 = 1d;
				for(k = 0d; k < n; k = k + 1d){
					if(k < j){
						t2 = t2*(xn1 - rs[(int)(k)]);
					}
					if(k > j){
						t2 = t2*(xn1 - rsPrev[(int)(k)]);
					}
				}
				t1 = t1/t2;
				rs[(int)(j)] = xn1 - t1;
			}
			withinPrecision = 0d;
			for(j = 0d; j < n; j = j + 1d){
				if(mathEpsilonCompare(rsPrev[(int)(j)], rs[(int)(j)], precision)){
					withinPrecision = withinPrecision + 1d;
				}
				rsPrev[(int)(j)] = rs[(int)(j)];
			}
			if(withinPrecision == n){
				success = true;
			}
		}

		rootsReference.numberArray = rs;

		return success;
	}


	public static bool FindRootsComplex(pComplexPolynomial p, cComplexNumberArrayReference rootsReference){
		return DurandKernerMethodComplex(p, 0.000001, 100d, rootsReference);
	}


	public static bool DurandKernerMethodComplex(pComplexPolynomial p, double precision, double maxIterations, cComplexNumberArrayReference rootsReference){
		bool success;
		double n, i, j, k, withinPrecision;
		cComplexNumber t1, t2, t3, xn1;
		cComplexNumber [] rs, rsPrev;

		n = p.cs.Length - 1d;
		rs = new cComplexNumber [(int)(n)];
		for(i = 0d; i < n; i = i + 1d){
			rs[(int)(i)] = cCreateComplexNumber(0d, 0d);
		}
		rsPrev = new cComplexNumber [(int)(n)];
		for(i = 0d; i < n; i = i + 1d){
			rsPrev[(int)(i)] = cCreateComplexNumber(0.4, 0.9);
			cPower(rsPrev[(int)(i)], i);
		}
		t2 = cCreateComplexNumber(0d, 0d);
		t3 = cCreateComplexNumber(0d, 0d);

		success = false;

		for(i = 0d; i < maxIterations && !success; i = i + 1d){
			for(j = 0d; j < n; j = j + 1d){
				xn1 = rsPrev[(int)(j)];

				t1 = pEvaluateComplex(p, xn1);
				cAssignComplexByValues(t2, 1d, 0d);
				for(k = 0d; k < n; k = k + 1d){
					if(k < j){
						cAssignComplex(t3, xn1);
						cSub(t3, rs[(int)(k)]);
						cMul(t2, t3);
					}
					if(k > j){
						cAssignComplex(t3, xn1);
						cSub(t3, rsPrev[(int)(k)]);
						cMul(t2, t3);
					}
				}
				cDiv(t1, t2);
				cAssignComplex(rs[(int)(j)], xn1);
				cSub(rs[(int)(j)], t1);
			}
			withinPrecision = 0d;
			for(j = 0d; j < n; j = j + 1d){
				if(cEpsilonCompareComplex(rsPrev[(int)(j)], rs[(int)(j)], precision)){
					withinPrecision = withinPrecision + 1d;
				}
				cAssignComplex(rsPrev[(int)(j)], rs[(int)(j)]);
			}
			if(withinPrecision == n){
				success = true;
			}
		}

		rootsReference.complexNumbers = rs;

		return success;
	}


	public static BooleanReference CreateBooleanReference(bool value){
		BooleanReference refx;

		refx = new BooleanReference();
		refx.booleanValue = value;

		return refx;
	}


	public static BooleanArrayReference CreateBooleanArrayReference(bool [] value){
		BooleanArrayReference refx;

		refx = new BooleanArrayReference();
		refx.booleanArray = value;

		return refx;
	}


	public static BooleanArrayReference CreateBooleanArrayReferenceLengthValue(double length, bool value){
		BooleanArrayReference refx;
		double i;

		refx = new BooleanArrayReference();
		refx.booleanArray = new bool [(int)(length)];

		for(i = 0d; i < length; i = i + 1d){
			refx.booleanArray[(int)(i)] = value;
		}

		return refx;
	}


	public static void FreeBooleanArrayReference(BooleanArrayReference booleanArrayReference){
		delete(booleanArrayReference.booleanArray);
		delete(booleanArrayReference);
	}


	public static CharacterReference CreateCharacterReference(char value){
		CharacterReference refx;

		refx = new CharacterReference();
		refx.characterValue = value;

		return refx;
	}


	public static NumberReference CreateNumberReference(double value){
		NumberReference refx;

		refx = new NumberReference();
		refx.numberValue = value;

		return refx;
	}


	public static NumberArrayReference CreateNumberArrayReference(double [] value){
		NumberArrayReference refx;

		refx = new NumberArrayReference();
		refx.numberArray = value;

		return refx;
	}


	public static NumberArrayReference CreateNumberArrayReferenceLengthValue(double length, double value){
		NumberArrayReference refx;
		double i;

		refx = new NumberArrayReference();
		refx.numberArray = new double [(int)(length)];

		for(i = 0d; i < length; i = i + 1d){
			refx.numberArray[(int)(i)] = value;
		}

		return refx;
	}


	public static void FreeNumberArrayReference(NumberArrayReference numberArrayReference){
		delete(numberArrayReference.numberArray);
		delete(numberArrayReference);
	}


	public static StringReference CreateStringReference(char [] value){
		StringReference refx;

		refx = new StringReference();
		refx.stringx = value;

		return refx;
	}


	public static StringReference CreateStringReferenceLengthValue(double length, char value){
		StringReference refx;
		double i;

		refx = new StringReference();
		refx.stringx = new char [(int)(length)];

		for(i = 0d; i < length; i = i + 1d){
			refx.stringx[(int)(i)] = value;
		}

		return refx;
	}


	public static void FreeStringReference(StringReference stringReference){
		delete(stringReference.stringx);
		delete(stringReference);
	}


	public static StringArrayReference CreateStringArrayReference(StringReference [] strings){
		StringArrayReference refx;

		refx = new StringArrayReference();
		refx.stringArray = strings;

		return refx;
	}


	public static StringArrayReference CreateStringArrayReferenceLengthValue(double length, char [] value){
		StringArrayReference refx;
		double i;

		refx = new StringArrayReference();
		refx.stringArray = new StringReference [(int)(length)];

		for(i = 0d; i < length; i = i + 1d){
			refx.stringArray[(int)(i)] = CreateStringReference(value);
		}

		return refx;
	}


	public static void FreeStringArrayReference(StringArrayReference stringArrayReference){
		double i;

		for(i = 0d; i < stringArrayReference.stringArray.Length; i = i + 1d){
			delete(stringArrayReference.stringArray[(int)(i)]);
		}
		delete(stringArrayReference.stringArray);
		delete(stringArrayReference);
	}


	public static double mathNegate(double x){
		return -x;
	}


	public static double mathPositive(double x){
		return +x;
	}


	public static double mathFactorial(double x){
		double i, f;

		f = 1d;

		for(i = 2d; i <= x; i = i + 1d){
			f = f*i;
		}

		return f;
	}


	public static double mathRound(double x){
		return Floor(x + 0.5);
	}


	public static double mathBankersRound(double x){
		double r;

		if(mathAbsolute(x - mathTruncate(x)) == 0.5){
			if(!mathDivisibleBy(mathRound(x), 2d)){
				r = mathRound(x) - 1d;
			}else{
				r = mathRound(x);
			}
		}else{
			r = mathRound(x);
		}

		return r;
	}


	public static double mathCeil(double x){
		return Ceiling(x);
	}


	public static double mathFloor(double x){
		return Floor(x);
	}


	public static double mathTruncate(double x){
		double t;

		if(x >= 0d){
			t = Floor(x);
		}else{
			t = Ceiling(x);
		}

		return t;
	}


	public static double mathAbsolute(double x){
		return Abs(x);
	}


	public static double mathLogarithm(double x){
		return Log10(x);
	}


	public static double mathNaturalLogarithm(double x){
		return Log(x);
	}


	public static double mathSin(double x){
		return Sin(x);
	}


	public static double mathCos(double x){
		return Cos(x);
	}


	public static double mathTan(double x){
		return Tan(x);
	}


	public static double mathAsin(double x){
		return Asin(x);
	}


	public static double mathAcos(double x){
		return Acos(x);
	}


	public static double mathAtan(double x){
		return Atan(x);
	}


	public static double mathAtan2(double y, double x){
		double a;

		/* Atan2 is an invalid operation when x = 0 and y = 0, but this method does not return errors.*/
		a = 0d;

		if(x > 0d){
			a = mathAtan(y/x);
		}else if(x < 0d && y >= 0d){
			a = mathAtan(y/x) + PI;
		}else if(x < 0d && y < 0d){
			a = mathAtan(y/x) - PI;
		}else if(x == 0d && y > 0d){
			a = PI/2d;
		}else if(x == 0d && y < 0d){
			a = -PI/2d;
		}

		return a;
	}


	public static double mathSquareroot(double x){
		return Sqrt(x);
	}


	public static double mathExp(double x){
		return Exp(x);
	}


	public static bool mathDivisibleBy(double a, double b){
		return ((a%b) == 0d);
	}


	public static double mathCombinations(double n, double k){
		double i, j, c;

		c = 1d;
		j = 1d;
		i = n - k + 1d;

		for(; i <= n; ){
			c = c*i;
			c = c/j;

			i = i + 1d;
			j = j + 1d;
		}

		return c;
	}


	public static double mathPermutations(double n, double k){
		double i, c;

		c = 1d;

		for(i = n - k + 1d; i <= n; i = i + 1d){
			c = c*i;
		}

		return c;
	}


	public static bool mathEpsilonCompare(double a, double b, double epsilon){
		return Abs(a - b) < epsilon;
	}


	public static double mathGreatestCommonDivisor(double a, double b){
		double t;

		for(; b != 0d; ){
			t = b;
			b = a%b;
			a = t;
		}

		return a;
	}


	public static double mathGCDWithSubtraction(double a, double b){
		double g;

		if(a == 0d){
			g = b;
		}else{
			for(; b != 0d; ){
				if(a > b){
					a = a - b;
				}else{
					b = b - a;
				}
			}

			g = a;
		}

		return g;
	}


	public static bool mathIsInteger(double a){
		return (a - Floor(a)) == 0d;
	}


	public static bool mathGreatestCommonDivisorWithCheck(double a, double b, NumberReference gcdReference){
		bool success;
		double gcd;

		if(mathIsInteger(a) && mathIsInteger(b)){
			gcd = mathGreatestCommonDivisor(a, b);
			gcdReference.numberValue = gcd;
			success = true;
		}else{
			success = false;
		}

		return success;
	}


	public static double mathLeastCommonMultiple(double a, double b){
		double lcm;

		if(a > 0d && b > 0d){
			lcm = Abs(a*b)/mathGreatestCommonDivisor(a, b);
		}else{
			lcm = 0d;
		}

		return lcm;
	}


	public static double mathSign(double a){
		double s;

		if(a > 0d){
			s = 1d;
		}else if(a < 0d){
			s = -1d;
		}else{
			s = 0d;
		}

		return s;
	}


	public static double mathMax(double a, double b){
		return Max(a, b);
	}


	public static double mathMin(double a, double b){
		return Min(a, b);
	}


	public static double mathPower(double a, double b){
		return Pow(a, b);
	}


	public static double mathGamma(double x){
		return mathLanczosApproximation(x);
	}


	public static double mathLogGamma(double x){
		return Log(mathGamma(x));
	}


	public static double mathLanczosApproximation(double z){
		double [] p;
		double i, y, t, x;

		p = new double [8];
		p[0] = 676.5203681218851;
		p[1] = -1259.1392167224028;
		p[2] = 771.32342877765313;
		p[3] = -176.61502916214059;
		p[4] = 12.507343278686905;
		p[5] = -0.13857109526572012;
		p[6] = 9.9843695780195716e-6;
		p[7] = 1.5056327351493116e-7;

		if(z < 0.5){
			y = PI/(Sin(PI*z)*mathLanczosApproximation(1d - z));
		}else{
			z = z - 1d;
			x = 0.99999999999980993;
			for(i = 0d; i < p.Length; i = i + 1d){
				x = x + p[(int)(i)]/(z + i + 1d);
			}
			t = z + p.Length - 0.5;
			y = Sqrt(2d*PI)*Pow(t, z + 0.5)*Exp(-t)*x;
		}

		return y;
	}


	public static double mathBeta(double x, double y){
		return mathGamma(x)*mathGamma(y)/mathGamma(x + y);
	}


	public static double mathSinh(double x){
		return (Exp(x) - Exp(-x))/2d;
	}


	public static double mathCosh(double x){
		return (Exp(x) + Exp(-x))/2d;
	}


	public static double mathTanh(double x){
		return mathSinh(x)/mathCosh(x);
	}


	public static double mathCot(double x){
		return 1d/Tan(x);
	}


	public static double mathSec(double x){
		return 1d/Cos(x);
	}


	public static double mathCsc(double x){
		return 1d/Sin(x);
	}


	public static double mathCoth(double x){
		return mathCosh(x)/mathSinh(x);
	}


	public static double mathSech(double x){
		return 1d/mathCosh(x);
	}


	public static double mathCsch(double x){
		return 1d/mathSinh(x);
	}


	public static double mathError(double x){
		double y, t, tau, c1, c2, c3, c4, c5, c6, c7, c8, c9, c10;

		if(x == 0d){
			y = 0d;
		}else if(x < 0d){
			y = -mathError(-x);
		}else{
			c1 = -1.26551223;
			c2 = +1.00002368;
			c3 = +0.37409196;
			c4 = +0.09678418;
			c5 = -0.18628806;
			c6 = +0.27886807;
			c7 = -1.13520398;
			c8 = +1.48851587;
			c9 = -0.82215223;
			c10 = +0.17087277;

			t = 1d/(1d + 0.5*Abs(x));

			tau = t*Exp(-Pow(x, 2d) + c1 + t*(c2 + t*(c3 + t*(c4 + t*(c5 + t*(c6 + t*(c7 + t*(c8 + t*(c9 + t*c10)))))))));

			y = 1d - tau;
		}

		return y;
	}


	public static double mathErrorInverse(double x){
		double y, a, t;

		a = (8d*(PI - 3d))/(3d*PI*(4d - PI));

		t = 2d/(PI*a) + Log(1d - Pow(x, 2d))/2d;
		y = mathSign(x)*Sqrt(Sqrt(Pow(t, 2d) - Log(1d - Pow(x, 2d))/a) - t);

		return y;
	}


	public static double mathFallingFactorial(double x, double n){
		double k, y;

		y = 1d;

		for(k = 0d; k <= n - 1d; k = k + 1d){
			y = y*(x - k);
		}

		return y;
	}


	public static double mathRisingFactorial(double x, double n){
		double k, y;

		y = 1d;

		for(k = 0d; k <= n - 1d; k = k + 1d){
			y = y*(x + k);
		}

		return y;
	}


	public static double mathHypergeometric(double a, double b, double c, double z, double maxIterations, double precision){
		double y;

		if(Abs(z) >= 0.5){
			y = Pow(1d - z, -a)*mathHypergeometricDirect(a, c - b, c, z/(z - 1d), maxIterations, precision);
		}else{
			y = mathHypergeometricDirect(a, b, c, z, maxIterations, precision);
		}

		return y;
	}


	public static double mathHypergeometricDirect(double a, double b, double c, double z, double maxIterations, double precision){
		double y, yp, n;
		bool done;

		y = 0d;
		done = false;

		for(n = 0d; n < maxIterations && !done; n = n + 1d){
			yp = mathRisingFactorial(a, n)*mathRisingFactorial(b, n)/mathRisingFactorial(c, n)*Pow(z, n)/mathFactorial(n);
			if(Abs(yp) < precision){
				done = true;
			}
			y = y + yp;
		}

		return y;
	}


	public static double mathBernouilliNumber(double n){
		return mathAkiyamaTanigawaAlgorithm(n);
	}


	public static double mathAkiyamaTanigawaAlgorithm(double n){
		double m, j, B;
		double [] A;

		A = new double [(int)(n + 1d)];

		for(m = 0d; m <= n; m = m + 1d){
			A[(int)(m)] = 1d/(m + 1d);
			for(j = m; j >= 1d; j = j - 1d){
				A[(int)(j - 1d)] = j*(A[(int)(j - 1d)] - A[(int)(j)]);
			}
		}

		B = A[0];

		delete(A);

		return B;
	}


	public static cComplexNumber cCreateComplexNumber(double re, double im){
		cComplexNumber z;

		z = new cComplexNumber();
		z.re = re;
		z.im = im;

		return z;
	}


	public static cPolarComplexNumber cCreatePolarComplexNumber(double r, double phi){
		cPolarComplexNumber p;

		p = new cPolarComplexNumber();
		p.r = r;
		p.phi = phi;

		return p;
	}


	public static void cAdd(cComplexNumber z1, cComplexNumber z2){
		double a, b, c, d;

		a = z1.re;
		b = z1.im;
		c = z2.re;
		d = z2.im;

		z1.re = a + c;
		z1.im = b + d;
	}


	public static cComplexNumber cAddToNew(cComplexNumber z1, cComplexNumber z2){
		cComplexNumber x;
		double a, b, c, d;

		a = z1.re;
		b = z1.im;
		c = z2.re;
		d = z2.im;

		x = new cComplexNumber();

		x.re = a + c;
		x.im = b + d;

		return x;
	}


	public static void cSub(cComplexNumber z1, cComplexNumber z2){
		double a, b, c, d;

		a = z1.re;
		b = z1.im;
		c = z2.re;
		d = z2.im;

		z1.re = a - c;
		z1.im = b - d;
	}


	public static cComplexNumber cSubToNew(cComplexNumber z1, cComplexNumber z2){
		cComplexNumber x;
		double a, b, c, d;

		a = z1.re;
		b = z1.im;
		c = z2.re;
		d = z2.im;

		x = new cComplexNumber();

		x.re = a - c;
		x.im = b - d;

		return x;
	}


	public static void cMul(cComplexNumber z1, cComplexNumber z2){
		double a, b, c, d;

		a = z1.re;
		b = z1.im;
		c = z2.re;
		d = z2.im;

		z1.re = a*c - b*d;
		z1.im = b*c + a*d;
	}


	public static cComplexNumber cMulToNew(cComplexNumber z1, cComplexNumber z2){
		cComplexNumber x;
		double a, b, c, d;

		a = z1.re;
		b = z1.im;
		c = z2.re;
		d = z2.im;

		x = new cComplexNumber();

		x.re = a*c - b*d;
		x.im = b*c + a*d;

		return x;
	}


	public static void cDiv(cComplexNumber z1, cComplexNumber z2){
		double a, b, c, d;

		a = z1.re;
		b = z1.im;
		c = z2.re;
		d = z2.im;

		z1.re = (a*c + b*d)/(Pow(c, 2d) + Pow(d, 2d));
		z1.im = (b*c - a*d)/(Pow(c, 2d) + Pow(d, 2d));
	}


	public static cComplexNumber cDivToNew(cComplexNumber z1, cComplexNumber z2){
		cComplexNumber x;
		double a, b, c, d;

		a = z1.re;
		b = z1.im;
		c = z2.re;
		d = z2.im;

		x = new cComplexNumber();

		x.re = (a*c + b*d)/(Pow(c, 2d) + Pow(d, 2d));
		x.im = (b*c - a*d)/(Pow(c, 2d) + Pow(d, 2d));

		return x;
	}


	public static void cConjugate(cComplexNumber z){
		z.im = -z.im;
	}


	public static cComplexNumber cConjugateToNew(cComplexNumber z){
		cComplexNumber x;

		x = new cComplexNumber();

		x.re = z.re;
		x.im = -z.im;

		return x;
	}


	public static double cAbs(cComplexNumber z){
		double x;

		x = Sqrt(Pow(z.re, 2d) + Pow(z.im, 2d));

		return x;
	}


	public static double cArg(cComplexNumber z){
		double x;

		x = mathAtan2(z.im, z.re);

		return x;
	}


	public static cPolarComplexNumber cCreatePolarFromComplexNumber(cComplexNumber z){
		cPolarComplexNumber x;

		x = new cPolarComplexNumber();

		x.r = cAbs(z);
		x.phi = cArg(z);

		return x;
	}


	public static cComplexNumber cCreateComplexFromPolar(cPolarComplexNumber p){
		cComplexNumber z;

		z = new cComplexNumber();

		z.re = p.r*Cos(p.phi);
		z.im = p.r*Sin(p.phi);

		return z;
	}


	public static double cRe(cComplexNumber z){
		return z.re;
	}


	public static double cIm(cComplexNumber z){
		return z.im;
	}


	public static void cAddPolar(cPolarComplexNumber p1, cPolarComplexNumber p2){
		cPolarComplexNumber x;
		cComplexNumber z1, z2;

		z1 = cCreateComplexFromPolar(p1);
		z2 = cCreateComplexFromPolar(p2);

		cAdd(z1, z2);

		x = cCreatePolarFromComplexNumber(z1);

		p1.r = x.r;
		p1.phi = x.phi;

		delete(z1);
		delete(z2);
		delete(x);
	}


	public static cPolarComplexNumber cAddPolarToNew(cPolarComplexNumber p1, cPolarComplexNumber p2){
		cPolarComplexNumber x;
		cComplexNumber z1, z2;

		z1 = cCreateComplexFromPolar(p1);
		z2 = cCreateComplexFromPolar(p2);

		cAdd(z1, z2);

		x = cCreatePolarFromComplexNumber(z1);

		delete(z1);
		delete(z2);

		return x;
	}


	public static void cSubPolar(cPolarComplexNumber p1, cPolarComplexNumber p2){
		cPolarComplexNumber x;
		cComplexNumber z1, z2;

		z1 = cCreateComplexFromPolar(p1);
		z2 = cCreateComplexFromPolar(p2);

		cSub(z1, z2);

		x = cCreatePolarFromComplexNumber(z1);

		p1.r = x.r;
		p1.phi = x.phi;

		delete(z1);
		delete(z2);
		delete(x);
	}


	public static cPolarComplexNumber cSubPolarToNew(cPolarComplexNumber p1, cPolarComplexNumber p2){
		cPolarComplexNumber x;
		cComplexNumber z1, z2;

		z1 = cCreateComplexFromPolar(p1);
		z2 = cCreateComplexFromPolar(p2);

		cSub(z1, z2);

		x = cCreatePolarFromComplexNumber(z1);

		delete(z1);
		delete(z2);

		return x;
	}


	public static void cMulPolar(cPolarComplexNumber p1, cPolarComplexNumber p2){
		double r1, r2, phi1, phi2;

		r1 = p1.r;
		r2 = p2.r;
		phi1 = p1.phi;
		phi2 = p2.phi;

		p1.r = r1*r2;
		p1.phi = phi1 + phi2;
	}


	public static cPolarComplexNumber cMulPolarToNew(cPolarComplexNumber p1, cPolarComplexNumber p2){
		cPolarComplexNumber x;
		double r1, r2, phi1, phi2;

		r1 = p1.r;
		r2 = p2.r;
		phi1 = p1.phi;
		phi2 = p2.phi;

		x = new cPolarComplexNumber();

		x.r = r1*r2;
		x.phi = phi1 + phi2;

		return x;
	}


	public static void cDivPolar(cPolarComplexNumber p1, cPolarComplexNumber p2){
		double r1, r2, phi1, phi2;

		r1 = p1.r;
		r2 = p2.r;
		phi1 = p1.phi;
		phi2 = p2.phi;

		p1.r = r1/r2;
		p1.phi = phi1 - phi2;
	}


	public static cPolarComplexNumber cDivPolarToNew(cPolarComplexNumber p1, cPolarComplexNumber p2){
		cPolarComplexNumber x;
		double r1, r2, phi1, phi2;

		r1 = p1.r;
		r2 = p2.r;
		phi1 = p1.phi;
		phi2 = p2.phi;

		x = new cPolarComplexNumber();

		x.r = r1/r2;
		x.phi = phi1 - phi2;

		return x;
	}


	public static void cSquareRoot(cComplexNumber z){
		double a, b, m;

		a = z.re;
		b = z.im;

		m = Sqrt(Pow(a, 2d) + Pow(b, 2d));

		z.re = Sqrt((m + a)/2d);
		z.im = mathSign(b)*Sqrt((m - a)/2d);
	}


	public static void cPowerPolar(cPolarComplexNumber p, double n){
		p.r = Pow(p.r, n);
		p.phi = p.phi*n;
	}


	public static cComplexNumber cPowerToNew(cComplexNumber z, double n){
		cPolarComplexNumber p;
		cComplexNumber zp;

		p = cCreatePolarFromComplexNumber(z);
		cPowerPolar(p, n);
		zp = cCreateComplexFromPolar(p);

		delete(p);

		return zp;
	}


	public static void cPower(cComplexNumber z, double n){
		cComplexNumber zp;

		zp = cPowerToNew(z, n);
		z.re = zp.re;
		z.im = zp.im;

		delete(zp);
	}


	public static void cNegate(cComplexNumber z){
		z.re = mathNegate(z.re);
		z.im = mathNegate(z.im);
	}


	public static void cAssignComplexByValues(cComplexNumber s, double re, double im){
		s.re = re;
		s.im = im;
	}


	public static void cAssignComplex(cComplexNumber a, cComplexNumber b){
		a.re = b.re;
		a.im = b.im;
	}


	public static bool cEpsilonCompareComplex(cComplexNumber a, cComplexNumber b, double epsilon){
		return mathEpsilonCompare(a.re, b.re, epsilon) && mathEpsilonCompare(a.im, b.im, epsilon);
	}


	public static void cExpComplex(cComplexNumber x){
		double re, im;

		re = Exp(x.re)*Cos(x.im);
		im = Exp(x.re)*Sin(x.im);
		x.re = re;
		x.im = im;
	}


	public static void cSineComplex(cComplexNumber x){
		double re, im;

		re = Sin(x.re)*mathCosh(x.im);
		im = Cos(x.re)*mathSinh(x.im);
		x.re = re;
		x.im = im;
	}


	public static void cCosineComplex(cComplexNumber x){
		double re, im;

		re = Cos(x.re)*mathCosh(x.im);
		im = Sin(x.re)*mathSinh(x.im);
		x.re = re;
		x.im = im;
	}


	public static char [] cComplexToString(cComplexNumber a){
		char [] str, number;
		LinkedListCharacters ll;
		double i;

		ll = CreateLinkedListCharacter();

		number = nCreateStringDecimalFromNumber(a.re);

		for(i = 0d; i < number.Length; i = i + 1d){
			LinkedListAddCharacter(ll, number[(int)(i)]);
		}

		delete(number);

		if(a.im < 0d){
			LinkedListAddCharacter(ll, '-');
			number = nCreateStringDecimalFromNumber(-a.im);
		}else{
			LinkedListAddCharacter(ll, '+');
			number = nCreateStringDecimalFromNumber(a.im);
		}

		for(i = 0d; i < number.Length; i = i + 1d){
			LinkedListAddCharacter(ll, number[(int)(i)]);
		}

		delete(number);

		LinkedListAddCharacter(ll, 'i');

		str = LinkedListCharactersToArray(ll);
		FreeLinkedListCharacter(ll);

		return str;
	}


	public static char [] pPolynomialToTextDirect(double [] p, char [] x){
		LinkedListCharacters ll;
		char [] str;
		double i, c, j;
		StringReference buffer;

		buffer = new StringReference();

		ll = CreateLinkedListCharacter();

		if(p.Length == 0d){
			LinkedListAddCharacter(ll, '0');
		}else{
			for(i = 0d; i < p.Length; i = i + 1d){
				c = p[(int)(i)];
				if(c < 0d){
					LinkedListAddCharacter(ll, '-');
				}else{
					LinkedListAddCharacter(ll, '+');
				}

				nCreateStringFromNumberWithCheck(Abs(c), 10d, buffer);
				pLinkedListCharactersAddString(ll, buffer.stringx);
				delete(buffer.stringx);

				pLinkedListCharactersAddString(ll, x);
				LinkedListAddCharacter(ll, '^');

				nCreateStringFromNumberWithCheck(i, 10d, buffer);
				pLinkedListCharactersAddString(ll, buffer.stringx);
				delete(buffer.stringx);
			}
		}

		str = LinkedListCharactersToArray(ll);
		FreeLinkedListCharacter(ll);

		return str;
	}


	public static void pLinkedListCharactersAddString(LinkedListCharacters ll, char [] str){
		double j;

		for(j = 0d; j < str.Length; j = j + 1d){
			LinkedListAddCharacter(ll, str[(int)(j)]);
		}
	}


	public static void pGenerateCommonRenderSpecification(double [] p, BooleanArrayReference showCoefficient, StringReference sign, NumberArrayReference coefficient, BooleanArrayReference showPower, BooleanArrayReference showX){
		double i, zeros, c;
		bool setZero;

		setZero = false;

		if(p.Length == 0d){
			setZero = true;
		}else{
			zeros = 0d;
			for(i = 0d; i < p.Length; i = i + 1d){
				if(p[(int)(i)] == 0d){
					zeros = zeros + 1d;
				}
			}

			if(zeros == p.Length){
				setZero = true;
			}else{
				showCoefficient.booleanArray = new bool [(int)(p.Length)];
				sign.stringx = new char [(int)(p.Length)];
				coefficient.numberArray = new double [(int)(p.Length)];
				showPower.booleanArray = new bool [(int)(p.Length)];
				showX.booleanArray = new bool [(int)(p.Length)];

				for(i = 0d; i < p.Length; i = i + 1d){
					c = p[(int)(i)];

					if(c < 0d){
						sign.stringx[(int)(i)] = '-';
					}else{
						sign.stringx[(int)(i)] = '+';
					}
					coefficient.numberArray[(int)(i)] = Abs(p[(int)(i)]);
					if(c == 0d){
						showCoefficient.booleanArray[(int)(i)] = false;
					}else{
if(Abs(c) == 1d && i > 0d){
							showCoefficient.booleanArray[(int)(i)] = false;
						}else{
							showCoefficient.booleanArray[(int)(i)] = true;
						}

						if(i == 0d){
							showX.booleanArray[(int)(i)] = false;
							showPower.booleanArray[(int)(i)] = false;
						}else{
							showX.booleanArray[(int)(i)] = true;
							if(i == 1d){
								showPower.booleanArray[(int)(i)] = false;
							}else{
								showPower.booleanArray[(int)(i)] = true;
							}
						}
					}
				}
			}
		}

		if(setZero){
			showCoefficient.booleanArray = new bool [1];
			sign.stringx = new char [1];
			coefficient.numberArray = new double [1];
			showPower.booleanArray = new bool [1];
			showX.booleanArray = new bool [1];

			showCoefficient.booleanArray[0] = true;
			sign.stringx[0] = '+';
			coefficient.numberArray[0] = 0d;
			showPower.booleanArray[0] = true;
			showX.booleanArray[0] = false;
		}
	}


	public static char [] pPolynomialToText(double [] p, char [] x){
		LinkedListCharacters ll;
		char [] str;
		double i, c;
		StringReference buffer;
		BooleanArrayReference showCoefficient, showPower, showX;
		StringReference sign;
		NumberArrayReference coefficient;
		bool hasPrinted;

		showCoefficient = CreateBooleanArrayReferenceLengthValue(0d, false);
		showPower = CreateBooleanArrayReferenceLengthValue(0d, false);
		showX = CreateBooleanArrayReferenceLengthValue(0d, false);
		sign = CreateStringReferenceLengthValue(0d, ' ');
		coefficient = CreateNumberArrayReferenceLengthValue(0d, 0d);

		pGenerateCommonRenderSpecification(p, showCoefficient, sign, coefficient, showPower, showX);

		buffer = CreateStringReferenceLengthValue(0d, ' ');

		ll = CreateLinkedListCharacter();

		hasPrinted = false;
		for(i = 0d; i < showCoefficient.booleanArray.Length; i = i + 1d){
			c = p[(int)(i)];

			if(showCoefficient.booleanArray[(int)(i)] || showX.booleanArray[(int)(i)]){
				if(!hasPrinted && c >= 0d){
				}else{
					LinkedListAddCharacter(ll, sign.stringx[(int)(i)]);
				}

				if(showCoefficient.booleanArray[(int)(i)]){
					nCreateStringFromNumberWithCheck(coefficient.numberArray[(int)(i)], 10d, buffer);
					pLinkedListCharactersAddString(ll, buffer.stringx);
					delete(buffer.stringx);
					hasPrinted = true;
				}

				if(showX.booleanArray[(int)(i)]){
					pLinkedListCharactersAddString(ll, x);
					hasPrinted = true;
					if(showPower.booleanArray[(int)(i)]){
						LinkedListAddCharacter(ll, '^');
						nCreateStringFromNumberWithCheck(i, 10d, buffer);
						pLinkedListCharactersAddString(ll, buffer.stringx);
						delete(buffer.stringx);
					}
				}
			}
		}

		str = LinkedListCharactersToArray(ll);
		FreeLinkedListCharacter(ll);

		return str;
	}


	public static char [] pComplexPolynomialToTextDirect(pComplexPolynomial p, char [] x){
		LinkedListCharacters ll;
		char [] str, number;
		double i;
		cComplexNumber c;
		StringReference buffer;

		buffer = new StringReference();

		ll = CreateLinkedListCharacter();

		if(p.cs.Length == 0d){
			LinkedListAddCharacter(ll, '0');
		}else{
			for(i = 0d; i < p.cs.Length; i = i + 1d){
				c = p.cs[(int)(i)];
				if(i > 0d){
					LinkedListAddCharacter(ll, '+');
				}

				number = cComplexToString(c);
				LinkedListAddCharacter(ll, '(');
				pLinkedListCharactersAddString(ll, number);
				LinkedListAddCharacter(ll, ')');
				delete(number);

				pLinkedListCharactersAddString(ll, x);
				LinkedListAddCharacter(ll, '^');

				nCreateStringFromNumberWithCheck(i, 10d, buffer);
				pLinkedListCharactersAddString(ll, buffer.stringx);
				delete(buffer.stringx);
			}
		}

		str = LinkedListCharactersToArray(ll);
		FreeLinkedListCharacter(ll);

		return str;
	}


	public static void pAdd(double [] a, double [] b){
		double i, nr;

		nr = b.Length;

		for(i = 0d; i < nr; i = i + 1d){
			a[(int)(i)] = a[(int)(i)] + b[(int)(i)];
		}
	}


	public static void pSubtract(double [] a, double [] b){
		double i, nr;

		nr = b.Length;

		for(i = 0d; i < nr; i = i + 1d){
			a[(int)(i)] = a[(int)(i)] - b[(int)(i)];
		}
	}


	public static void pMultiply(double [] c, double [] a, double [] b){
		double k, n, m, i;
		double av, bv;

		n = pDegree(a);
		m = pDegree(b);

		pFill(c, 0d);

		for(i = 0d; i <= n + m; i = i + 1d){
			c[(int)(i)] = 0d;
			for(k = 0d; k <= i && k < a.Length && i - k < b.Length; k = k + 1d){
				av = a[(int)(k)];
				bv = b[(int)(i - k)];
				c[(int)(i)] = c[(int)(i)] + av*bv;
			}
		}
	}


	public static void pDivide(double [] q, double [] r, double [] n, double [] d){
		double [] t, t1;
		double tcoff, tdegree, i;
		double deg;
		double rd, dd;

		pFill(q, 0d);
		pAssign(r, n);
		deg = pDegree(n);
		t = pCreatePolynomial(deg);
		t1 = pCreatePolynomial(deg);

		rd = pDegree(r);
		dd = pDegree(d);
		for(i = 0d; i < deg + 1d && !pIsZero(r) && rd - i >= dd; i = i + 1d){
			pFill(t, 0d);
			tdegree = rd - i - dd;
			tcoff = r[(int)(rd - i)]/d[(int)(dd)];
			t[(int)(tdegree)] = tcoff;
			pAdd(q, t);
			pFill(t1, 0d);
			pMultiply(t1, t, d);
			pSubtract(r, t1);
		}

		delete(t);
		delete(t1);
	}


	public static bool pIsZero(double [] a){
		double i;
		bool itIsZero;

		itIsZero = true;

		for(i = 0d; i < a.Length; i = i + 1d){
			if(a[(int)(i)] != 0d){
				itIsZero = false;
			}
		}

		return itIsZero;
	}


	public static void pAssign(double [] a, double [] b){
		double i, nr;

		nr = b.Length;

		for(i = 0d; i < nr; i = i + 1d){
			a[(int)(i)] = b[(int)(i)];
		}
	}


	public static double [] pCreatePolynomial(double deg){
		double [] p;

		p = new double [(int)(deg + 1d)];

		pFill(p, 0d);

		return p;
	}


	public static void pFill(double [] p, double value){
		double i;

		for(i = 0d; i < p.Length; i = i + 1d){
			p[(int)(i)] = value;
		}
	}


	public static double pDegree(double [] A){
		double i;
		double deg;
		bool done;

		done = false;
		deg = 0d;
		for(i = A.Length - 1d; i >= 0d && !done; i = i - 1d){
			if(A[(int)(i)] != 0d){
				deg = i;
				done = true;
			}
		}

		return deg;
	}


	public static double pLead(double [] A){
		double deg;

		deg = pDegree(A);

		return A[(int)(deg)];
	}


	public static double pEvaluate(double [] A, double x){
		return pEvaluateWithHornersMethod(A, x);
	}


	public static double pEvaluateWithHornersMethod(double [] A, double x){
		double r, i;

		r = 0d;

		for(i = A.Length - 1d; i >= 0d; i = i - 1d){
			r = r*x;
			r = A[(int)(i)] + r;
		}

		return r;
	}


	public static double pEvaluateWithPowers(double [] A, double x){
		double r, i;

		r = 0d;

		for(i = 0d; i < A.Length; i = i + 1d){
			r = r + A[(int)(i)]*Pow(x, i);
		}

		return r;
	}


	public static double pEvaluateDerivative(double [] A, double x, double n){
		double r, i, v;

		r = 0d;

		for(i = 0d; i < A.Length; i = i + 1d){
			if(i - n >= 0d){
				/*v = A[(int) i] * mFactorial(n) * mCombinations(i, n) * pow(x, i - n);*/
				v = A[(int)(i)]*mathPermutations(i, n)*Pow(x, i - n);
				r = r + v;
			}
		}

		return r;
	}


	public static void pDerivative(double [] A){
		double i, degree;

		degree = 0d;
		for(i = 1d; i < A.Length; i = i + 1d){
			degree = degree + 1d;
			A[(int)(i - 1d)] = degree*A[(int)(i)];
		}

		A[(int)(A.Length - 1d)] = 0d;
	}


	public static void pAddComplex(pComplexPolynomial a, pComplexPolynomial b){
		double i, nr;

		nr = a.cs.Length;

		for(i = 0d; i < nr; i = i + 1d){
			cAdd(a.cs[(int)(i)], b.cs[(int)(i)]);
		}
	}


	public static void pSubtractComplex(pComplexPolynomial a, pComplexPolynomial b){
		double i, nr;

		nr = a.cs.Length;

		for(i = 0d; i < nr; i = i + 1d){
			cSub(a.cs[(int)(i)], b.cs[(int)(i)]);
		}
	}


	public static bool pIsZeroComplex(pComplexPolynomial a){
		double i;
		bool itIsZero;

		itIsZero = true;

		for(i = 0d; i < a.cs.Length; i = i + 1d){
			if(a.cs[(int)(i)].re != 0d && a.cs[(int)(i)].im != 0d){
				itIsZero = false;
			}
		}

		return itIsZero;
	}


	public static void pAssignComplex(pComplexPolynomial a, pComplexPolynomial b){
		double i, nr;

		nr = b.cs.Length;

		for(i = 0d; i < nr; i = i + 1d){
			cAssignComplex(a.cs[(int)(i)], b.cs[(int)(i)]);
		}
	}


	public static pComplexPolynomial pCreateComplexPolynomial(double deg){
		pComplexPolynomial p;
		double i;

		p = new pComplexPolynomial();
		p.cs = new cComplexNumber [(int)(deg + 1d)];

		for(i = 0d; i < deg + 1d; i = i + 1d){
			p.cs[(int)(i)] = new cComplexNumber();
		}

		pFillComplex(p, 0d, 0d);

		return p;
	}


	public static void pFillComplex(pComplexPolynomial p, double re, double im){
		double i;
		cComplexNumber c;

		c = cCreateComplexNumber(re, im);

		for(i = 0d; i < p.cs.Length; i = i + 1d){
			cAssignComplex(p.cs[(int)(i)], c);
		}

		delete(c);
	}


	public static double pDegreeComplex(pComplexPolynomial A){
		double i;
		double deg;
		bool done;

		done = false;
		deg = 0d;
		for(i = A.cs.Length - 1d; i >= 0d && !done; i = i - 1d){
			if(A.cs[(int)(i)].re != 0d && A.cs[(int)(i)].im != 0d){
				deg = i;
				done = true;
			}
		}

		return deg;
	}


	public static cComplexNumber pLeadComplex(pComplexPolynomial A){
		double deg;

		deg = pDegreeComplex(A);

		return A.cs[(int)(deg)];
	}


	public static cComplexNumber pEvaluateComplex(pComplexPolynomial A, cComplexNumber x){
		double i;
		cComplexNumber r, t;

		r = cCreateComplexNumber(0d, 0d);
		t = cCreateComplexNumber(0d, 0d);

		for(i = 0d; i < A.cs.Length; i = i + 1d){
			cAssignComplex(t, x);
			cPower(t, i);
			cMul(t, A.cs[(int)(i)]);
			cAdd(r, t);
		}

		return r;
	}


	public static double pTotalNumberOfRoots(double [] p){
		return pDegree(p);
	}


	public static void WriteStringToStingStream(char [] stream, NumberReference index, char [] src){
		double i;

		for(i = 0d; i < src.Length; i = i + 1d){
			stream[(int)(index.numberValue + i)] = src[(int)(i)];
		}
		index.numberValue = index.numberValue + src.Length;
	}


	public static void WriteCharacterToStingStream(char [] stream, NumberReference index, char src){
		stream[(int)(index.numberValue)] = src;
		index.numberValue = index.numberValue + 1d;
	}


	public static void WriteBooleanToStingStream(char [] stream, NumberReference index, bool src){
		if(src){
			WriteStringToStingStream(stream, index, "true".ToCharArray());
		}else{
			WriteStringToStingStream(stream, index, "false".ToCharArray());
		}
	}


	public static bool SubstringWithCheck(char [] stringx, double from, double to, StringReference stringReference){
		bool success;

		if(from >= 0d && from <= stringx.Length && to >= 0d && to <= stringx.Length && from <= to){
			stringReference.stringx = Substring(stringx, from, to);
			success = true;
		}else{
			success = false;
		}

		return success;
	}


	public static char [] Substring(char [] stringx, double from, double to){
		char [] n;
		double i, length;

		length = to - from;

		n = new char [(int)(length)];

		for(i = from; i < to; i = i + 1d){
			n[(int)(i - from)] = stringx[(int)(i)];
		}

		return n;
	}


	public static char [] AppendString(char [] s1, char [] s2){
		char [] newString;

		newString = ConcatenateString(s1, s2);

		delete(s1);

		return newString;
	}


	public static char [] ConcatenateString(char [] s1, char [] s2){
		char [] newString;
		double i;

		newString = new char [(int)(s1.Length + s2.Length)];

		for(i = 0d; i < s1.Length; i = i + 1d){
			newString[(int)(i)] = s1[(int)(i)];
		}

		for(i = 0d; i < s2.Length; i = i + 1d){
			newString[(int)(s1.Length + i)] = s2[(int)(i)];
		}

		return newString;
	}


	public static char [] AppendCharacter(char [] stringx, char c){
		char [] newString;

		newString = ConcatenateCharacter(stringx, c);

		delete(stringx);

		return newString;
	}


	public static char [] ConcatenateCharacter(char [] stringx, char c){
		char [] newString;
		double i;
		newString = new char [(int)(stringx.Length + 1d)];

		for(i = 0d; i < stringx.Length; i = i + 1d){
			newString[(int)(i)] = stringx[(int)(i)];
		}

		newString[(int)(stringx.Length)] = c;

		return newString;
	}


	public static StringReference [] SplitByCharacter(char [] toSplit, char splitBy){
		StringReference [] split;
		char [] stringToSplitBy;

		stringToSplitBy = new char [1];
		stringToSplitBy[0] = splitBy;

		split = SplitByString(toSplit, stringToSplitBy);

		delete(stringToSplitBy);

		return split;
	}


	public static bool IndexOfCharacter(char [] stringx, char character, NumberReference indexReference){
		double i;
		bool found;

		found = false;
		for(i = 0d; i < stringx.Length && !found; i = i + 1d){
			if(stringx[(int)(i)] == character){
				found = true;
				indexReference.numberValue = i;
			}
		}

		return found;
	}


	public static bool SubstringEqualsWithCheck(char [] stringx, double from, char [] substring, BooleanReference equalsReference){
		bool success;

		if(from < stringx.Length){
			success = true;
			equalsReference.booleanValue = SubstringEquals(stringx, from, substring);
		}else{
			success = false;
		}

		return success;
	}


	public static bool SubstringEquals(char [] stringx, double from, char [] substring){
		double i;
		bool equal;

		equal = true;
		for(i = 0d; i < substring.Length && equal; i = i + 1d){
			if(stringx[(int)(from + i)] != substring[(int)(i)]){
				equal = false;
			}
		}

		return equal;
	}


	public static bool IndexOfString(char [] stringx, char [] substring, NumberReference indexReference){
		double i;
		bool found;

		found = false;
		for(i = 0d; i < stringx.Length - substring.Length + 1d && !found; i = i + 1d){
			if(SubstringEquals(stringx, i, substring)){
				found = true;
				indexReference.numberValue = i;
			}
		}

		return found;
	}


	public static bool ContainsCharacter(char [] stringx, char character){
		double i;
		bool found;

		found = false;
		for(i = 0d; i < stringx.Length && !found; i = i + 1d){
			if(stringx[(int)(i)] == character){
				found = true;
			}
		}

		return found;
	}


	public static bool ContainsString(char [] stringx, char [] substring){
		return IndexOfString(stringx, substring, new NumberReference());
	}


	public static void ToUpperCase(char [] stringx){
		double i;

		for(i = 0d; i < stringx.Length; i = i + 1d){
			stringx[(int)(i)] = charToUpperCase(stringx[(int)(i)]);
		}
	}


	public static void ToLowerCase(char [] stringx){
		double i;

		for(i = 0d; i < stringx.Length; i = i + 1d){
			stringx[(int)(i)] = charToLowerCase(stringx[(int)(i)]);
		}
	}


	public static bool EqualsIgnoreCase(char [] a, char [] b){
		bool equal;
		double i;

		if(a.Length == b.Length){
			equal = true;
			for(i = 0d; i < a.Length && equal; i = i + 1d){
				if(charToLowerCase(a[(int)(i)]) != charToLowerCase(b[(int)(i)])){
					equal = false;
				}
			}
		}else{
			equal = false;
		}

		return equal;
	}


	public static char [] ReplaceString(char [] stringx, char [] toReplace, char [] replaceWith){
		char [] result;
		double i;
		BooleanReference equalsReference;
		bool success;

		equalsReference = new BooleanReference();
		result = new char [0];

		for(i = 0d; i < stringx.Length; ){
			success = SubstringEqualsWithCheck(stringx, i, toReplace, equalsReference);
			if(success){
				success = equalsReference.booleanValue;
			}

			if(success && toReplace.Length > 0d){
				result = ConcatenateString(result, replaceWith);
				i = i + toReplace.Length;
			}else{
				result = ConcatenateCharacter(result, stringx[(int)(i)]);
				i = i + 1d;
			}
		}

		return result;
	}


	public static char [] ReplaceCharacter(char [] stringx, char toReplace, char replaceWith){
		char [] result;
		double i;

		result = new char [0];

		for(i = 0d; i < stringx.Length; i = i + 1d){
			if(stringx[(int)(i)] == toReplace){
				result = ConcatenateCharacter(result, replaceWith);
			}else{
				result = ConcatenateCharacter(result, stringx[(int)(i)]);
			}
		}

		return result;
	}


	public static char [] Trim(char [] stringx){
		char [] result;
		double i, lastWhitespaceLocationStart, lastWhitespaceLocationEnd;
		bool firstNonWhitespaceFound;

		/* Find whitepaces at the start.*/
		lastWhitespaceLocationStart = -1d;
		firstNonWhitespaceFound = false;
		for(i = 0d; i < stringx.Length && !firstNonWhitespaceFound; i = i + 1d){
			if(charIsWhiteSpace(stringx[(int)(i)])){
				lastWhitespaceLocationStart = i;
			}else{
				firstNonWhitespaceFound = true;
			}
		}

		/* Find whitepaces at the end.*/
		lastWhitespaceLocationEnd = stringx.Length;
		firstNonWhitespaceFound = false;
		for(i = stringx.Length - 1d; i >= 0d && !firstNonWhitespaceFound; i = i - 1d){
			if(charIsWhiteSpace(stringx[(int)(i)])){
				lastWhitespaceLocationEnd = i;
			}else{
				firstNonWhitespaceFound = true;
			}
		}

		if(lastWhitespaceLocationStart < lastWhitespaceLocationEnd){
			result = Substring(stringx, lastWhitespaceLocationStart + 1d, lastWhitespaceLocationEnd);
		}else{
			result = new char [0];
		}

		return result;
	}


	public static bool StartsWith(char [] stringx, char [] start){
		bool startsWithString;

		startsWithString = false;
		if(stringx.Length >= start.Length){
			startsWithString = SubstringEquals(stringx, 0d, start);
		}

		return startsWithString;
	}


	public static bool EndsWith(char [] stringx, char [] end){
		bool endsWithString;

		endsWithString = false;
		if(stringx.Length >= end.Length){
			endsWithString = SubstringEquals(stringx, stringx.Length - end.Length, end);
		}

		return endsWithString;
	}


	public static StringReference [] SplitByString(char [] toSplit, char [] splitBy){
		StringReference [] split;
		char [] next;
		double i;
		char c;
		StringReference n;

		split = new StringReference [0];

		next = new char [0];
		for(i = 0d; i < toSplit.Length; ){
			c = toSplit[(int)(i)];

			if(SubstringEquals(toSplit, i, splitBy)){
				if(split.Length != 0d || i != 0d){
					n = new StringReference();
					n.stringx = next;
					split = AddString(split, n);
					next = new char [0];
					i = i + splitBy.Length;
				}
			}else{
				next = AppendCharacter(next, c);
				i = i + 1d;
			}
		}

		if(next.Length > 0d){
			n = new StringReference();
			n.stringx = next;
			split = AddString(split, n);
		}

		return split;
	}


	public static bool StringIsBefore(char [] a, char [] b){
		bool before, equal, done;
		double i;

		before = false;
		equal = true;
		done = false;

		if(a.Length == 0d && b.Length > 0d){
			before = true;
		}else{
			for(i = 0d; i < a.Length && i < b.Length && !done; i = i + 1d){
				if(a[(int)(i)] != b[(int)(i)]){
					equal = false;
				}
				if(charCharacterIsBefore(a[(int)(i)], b[(int)(i)])){
					before = true;
				}
				if(charCharacterIsBefore(b[(int)(i)], a[(int)(i)])){
					done = true;
				}
			}

			if(equal){
				if(a.Length < b.Length){
					before = true;
				}
			}
		}

		return before;
	}


	public static char [] nCreateStringScientificNotationDecimalFromNumber(double decimalx){
		StringReference mantissaReference, exponentReference;
		double multiplier, inc;
		double exponent;
		bool done, isPositive;
		char [] result;

		mantissaReference = new StringReference();
		exponentReference = new StringReference();
		result = new char [0];
		done = false;
		exponent = 0d;

		if(decimalx < 0d){
			isPositive = false;
			decimalx = -decimalx;
		}else{
			isPositive = true;
		}

		if(decimalx == 0d){
			done = true;
		}

		if(!done){
			multiplier = 0d;
			inc = 0d;

			if(decimalx < 1d){
				multiplier = 10d;
				inc = -1d;
			}else if(decimalx >= 10d){
				multiplier = 0.1;
				inc = 1d;
			}else{
				done = true;
			}

			if(!done){
				for(; decimalx >= 10d || decimalx < 1d; ){
					decimalx = decimalx*multiplier;
					exponent = exponent + inc;
				}
			}
		}

		nCreateStringFromNumberWithCheck(decimalx, 10d, mantissaReference);

		nCreateStringFromNumberWithCheck(exponent, 10d, exponentReference);

		if(!isPositive){
			result = AppendString(result, "-".ToCharArray());
		}

		result = AppendString(result, mantissaReference.stringx);
		result = AppendString(result, "e".ToCharArray());
		result = AppendString(result, exponentReference.stringx);

		return result;
	}


	public static char [] nCreateStringDecimalFromNumber(double decimalx){
		StringReference stringReference;

		stringReference = new StringReference();

		/* This will succeed because base = 10.*/
		nCreateStringFromNumberWithCheck(decimalx, 10d, stringReference);

		return stringReference.stringx;
	}


	public static bool nCreateStringFromNumberWithCheck(double decimalx, double basex, StringReference stringReference){
		char [] stringx;
		double maximumDigits;
		double digitPosition;
		bool hasPrintedPoint, isPositive;
		double i, d;
		bool success;
		CharacterReference characterReference;
		char c;

		isPositive = true;

		if(decimalx < 0d){
			isPositive = false;
			decimalx = -decimalx;
		}

		if(decimalx == 0d){
			stringReference.stringx = "0".ToCharArray();
			success = true;
		}else{
			characterReference = new CharacterReference();

			if(mathIsInteger(basex)){
				success = true;

				stringx = new char [0];

				maximumDigits = nGetMaximumDigitsForBase(basex);

				digitPosition = nGetFirstDigitPosition(decimalx, basex);

				decimalx = (double)Round(decimalx*Pow(basex, maximumDigits - digitPosition - 1d));

				hasPrintedPoint = false;

				if(!isPositive){
					stringx = AppendCharacter(stringx, '-');
				}

				/* Print leading zeros.*/
				if(digitPosition < 0d){
					stringx = AppendCharacter(stringx, '0');
					stringx = AppendCharacter(stringx, '.');
					hasPrintedPoint = true;
					for(i = 0d; i < -digitPosition - 1d; i = i + 1d){
						stringx = AppendCharacter(stringx, '0');
					}
				}

				/* Print number.*/
				for(i = 0d; i < maximumDigits && success; i = i + 1d){
					d = Floor(decimalx/Pow(basex, maximumDigits - i - 1d));

					if(d >= basex){
						d = basex - 1d;
					}

					if(!hasPrintedPoint && digitPosition - i + 1d == 0d){
						if(decimalx != 0d){
							stringx = AppendCharacter(stringx, '.');
						}
						hasPrintedPoint = true;
					}

					if(decimalx == 0d && hasPrintedPoint){
					}else{
						success = nGetSingleDigitCharacterFromNumberWithCheck(d, basex, characterReference);
						if(success){
							c = characterReference.characterValue;
							stringx = AppendCharacter(stringx, c);
						}
					}

					if(success){
						decimalx = decimalx - d*Pow(basex, maximumDigits - i - 1d);
					}
				}

				if(success){
					/* Print trailing zeros.*/
					for(i = 0d; i < digitPosition - maximumDigits + 1d; i = i + 1d){
						stringx = AppendCharacter(stringx, '0');
					}

					stringReference.stringx = stringx;
				}
			}else{
				success = false;
			}
		}

		/* Done*/
		return success;
	}


	public static double nGetMaximumDigitsForBase(double basex){
		double t;

		t = Pow(10d, 15d);
		return Floor(Log10(t)/Log10(basex));
	}


	public static double nGetFirstDigitPosition(double decimalx, double basex){
		double power;
		double t;

		power = Ceiling(Log10(decimalx)/Log10(basex));

		t = decimalx*Pow(basex, -power);
		if(t < basex && t >= 1d){
		}else if(t >= basex){
			power = power + 1d;
		}else if(t < 1d){
			power = power - 1d;
		}

		return power;
	}


	public static bool nGetSingleDigitCharacterFromNumberWithCheck(double c, double basex, CharacterReference characterReference){
		char [] numberTable;
		bool success;

		numberTable = nGetDigitCharacterTable();

		if(c < basex || c < numberTable.Length){
			success = true;
			characterReference.characterValue = numberTable[(int)(c)];
		}else{
			success = false;
		}

		return success;
	}


	public static char [] nGetDigitCharacterTable(){
		char [] numberTable;

		numberTable = "0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ".ToCharArray();

		return numberTable;
	}


	public static bool nCreateNumberFromDecimalStringWithCheck(char [] stringx, NumberReference decimalReference, StringReference errorMessage){
		return nCreateNumberFromStringWithCheck(stringx, 10d, decimalReference, errorMessage);
	}


	public static double nCreateNumberFromDecimalString(char [] stringx){
		NumberReference doubleReference;
		StringReference stringReference;
		double number;

		doubleReference = CreateNumberReference(0d);
		stringReference = CreateStringReference("".ToCharArray());
		nCreateNumberFromStringWithCheck(stringx, 10d, doubleReference, stringReference);
		number = doubleReference.numberValue;

		delete(doubleReference);
		delete(stringReference);

		return number;
	}


	public static bool nCreateNumberFromStringWithCheck(char [] stringx, double basex, NumberReference numberReference, StringReference errorMessage){
		bool success;
		BooleanReference numberIsPositive, exponentIsPositive;
		NumberArrayReference beforePoint, afterPoint, exponent;

		numberIsPositive = CreateBooleanReference(true);
		exponentIsPositive = CreateBooleanReference(true);
		beforePoint = new NumberArrayReference();
		afterPoint = new NumberArrayReference();
		exponent = new NumberArrayReference();

		if(basex >= 2d && basex <= 36d){
			success = nExtractPartsFromNumberString(stringx, basex, numberIsPositive, beforePoint, afterPoint, exponentIsPositive, exponent, errorMessage);

			if(success){
				numberReference.numberValue = nCreateNumberFromParts(basex, numberIsPositive.booleanValue, beforePoint.numberArray, afterPoint.numberArray, exponentIsPositive.booleanValue, exponent.numberArray);
			}
		}else{
			success = false;
			errorMessage.stringx = "Base must be from 2 to 36.".ToCharArray();
		}

		return success;
	}


	public static double nCreateNumberFromParts(double basex, bool numberIsPositive, double [] beforePoint, double [] afterPoint, bool exponentIsPositive, double [] exponent){
		double n, i, p, e;

		n = 0d;

		for(i = 0d; i < beforePoint.Length; i = i + 1d){
			p = beforePoint[(int)(beforePoint.Length - i - 1d)];

			n = n + p*Pow(basex, i);
		}

		for(i = 0d; i < afterPoint.Length; i = i + 1d){
			p = afterPoint[(int)(i)];

			n = n + p*Pow(basex, -(i + 1d));
		}

		if(exponent.Length > 0d){
			e = 0d;
			for(i = 0d; i < exponent.Length; i = i + 1d){
				p = exponent[(int)(exponent.Length - i - 1d)];

				e = e + p*Pow(basex, i);
			}

			if(!exponentIsPositive){
				e = -e;
			}

			n = n*Pow(basex, e);
		}

		if(!numberIsPositive){
			n = -n;
		}

		return n;
	}


	public static bool nExtractPartsFromNumberString(char [] n, double basex, BooleanReference numberIsPositive, NumberArrayReference beforePoint, NumberArrayReference afterPoint, BooleanReference exponentIsPositive, NumberArrayReference exponent, StringReference errorMessages){
		double i;
		bool success;

		i = 0d;

		if(i < n.Length){
			if(n[(int)(i)] == '-'){
				numberIsPositive.booleanValue = false;
				i = i + 1d;
			}else if(n[(int)(i)] == '+'){
				numberIsPositive.booleanValue = true;
				i = i + 1d;
			}

			success = nExtractPartsFromNumberStringFromSign(n, basex, i, beforePoint, afterPoint, exponentIsPositive, exponent, errorMessages);
		}else{
			success = false;
			errorMessages.stringx = "Number cannot have length zero.".ToCharArray();
		}

		return success;
	}


	public static bool nExtractPartsFromNumberStringFromSign(char [] n, double basex, double i, NumberArrayReference beforePoint, NumberArrayReference afterPoint, BooleanReference exponentIsPositive, NumberArrayReference exponent, StringReference errorMessages){
		bool success, done;
		double count, j;

		done = false;
		count = 0d;
		for(; i + count < n.Length && !done; ){
			if(nCharacterIsNumberCharacterInBase(n[(int)(i + count)], basex)){
				count = count + 1d;
			}else{
				done = true;
			}
		}

		if(count >= 1d){
			beforePoint.numberArray = new double [(int)(count)];

			for(j = 0d; j < count; j = j + 1d){
				beforePoint.numberArray[(int)(j)] = nGetNumberFromNumberCharacterForBase(n[(int)(i + j)], basex);
			}

			i = i + count;

			if(i < n.Length){
				success = nExtractPartsFromNumberStringFromPointOrExponent(n, basex, i, afterPoint, exponentIsPositive, exponent, errorMessages);
			}else{
				afterPoint.numberArray = new double [0];
				exponent.numberArray = new double [0];
				success = true;
			}
		}else{
			success = false;
			errorMessages.stringx = "Number must have at least one number after the optional sign.".ToCharArray();
		}

		return success;
	}


	public static bool nExtractPartsFromNumberStringFromPointOrExponent(char [] n, double basex, double i, NumberArrayReference afterPoint, BooleanReference exponentIsPositive, NumberArrayReference exponent, StringReference errorMessages){
		bool success, done;
		double count, j;

		if(n[(int)(i)] == '.'){
			i = i + 1d;

			if(i < n.Length){
				done = false;
				count = 0d;
				for(; i + count < n.Length && !done; ){
					if(nCharacterIsNumberCharacterInBase(n[(int)(i + count)], basex)){
						count = count + 1d;
					}else{
						done = true;
					}
				}

				if(count >= 1d){
					afterPoint.numberArray = new double [(int)(count)];

					for(j = 0d; j < count; j = j + 1d){
						afterPoint.numberArray[(int)(j)] = nGetNumberFromNumberCharacterForBase(n[(int)(i + j)], basex);
					}

					i = i + count;

					if(i < n.Length){
						success = nExtractPartsFromNumberStringFromExponent(n, basex, i, exponentIsPositive, exponent, errorMessages);
					}else{
						exponent.numberArray = new double [0];
						success = true;
					}
				}else{
					success = false;
					errorMessages.stringx = "There must be at least one digit after the decimal point.".ToCharArray();
				}
			}else{
				success = false;
				errorMessages.stringx = "There must be at least one digit after the decimal point.".ToCharArray();
			}
		}else if(basex <= 14d && (n[(int)(i)] == 'e' || n[(int)(i)] == 'E')){
			if(i < n.Length){
				success = nExtractPartsFromNumberStringFromExponent(n, basex, i, exponentIsPositive, exponent, errorMessages);
				afterPoint.numberArray = new double [0];
			}else{
				success = false;
				errorMessages.stringx = "There must be at least one digit after the exponent.".ToCharArray();
			}
		}else{
			success = false;
			errorMessages.stringx = "Expected decimal point or exponent symbol.".ToCharArray();
		}

		return success;
	}


	public static bool nExtractPartsFromNumberStringFromExponent(char [] n, double basex, double i, BooleanReference exponentIsPositive, NumberArrayReference exponent, StringReference errorMessages){
		bool success, done;
		double count, j;

		if(basex <= 14d && (n[(int)(i)] == 'e' || n[(int)(i)] == 'E')){
			i = i + 1d;

			if(i < n.Length){
				if(n[(int)(i)] == '-'){
					exponentIsPositive.booleanValue = false;
					i = i + 1d;
				}else if(n[(int)(i)] == '+'){
					exponentIsPositive.booleanValue = true;
					i = i + 1d;
				}

				if(i < n.Length){
					done = false;
					count = 0d;
					for(; i + count < n.Length && !done; ){
						if(nCharacterIsNumberCharacterInBase(n[(int)(i + count)], basex)){
							count = count + 1d;
						}else{
							done = true;
						}
					}

					if(count >= 1d){
						exponent.numberArray = new double [(int)(count)];

						for(j = 0d; j < count; j = j + 1d){
							exponent.numberArray[(int)(j)] = nGetNumberFromNumberCharacterForBase(n[(int)(i + j)], basex);
						}

						i = i + count;

						if(i == n.Length){
							success = true;
						}else{
							success = false;
							errorMessages.stringx = "There cannot be any characters past the exponent of the number.".ToCharArray();
						}
					}else{
						success = false;
						errorMessages.stringx = "There must be at least one digit after the decimal point.".ToCharArray();
					}
				}else{
					success = false;
					errorMessages.stringx = "There must be at least one digit after the exponent symbol.".ToCharArray();
				}
			}else{
				success = false;
				errorMessages.stringx = "There must be at least one digit after the exponent symbol.".ToCharArray();
			}
		}else{
			success = false;
			errorMessages.stringx = "Expected exponent symbol.".ToCharArray();
		}

		return success;
	}


	public static double nGetNumberFromNumberCharacterForBase(char c, double basex){
		char [] numberTable;
		double i;
		double position;

		numberTable = nGetDigitCharacterTable();
		position = 0d;

		for(i = 0d; i < basex; i = i + 1d){
			if(numberTable[(int)(i)] == c){
				position = i;
			}
		}

		return position;
	}


	public static bool nCharacterIsNumberCharacterInBase(char c, double basex){
		char [] numberTable;
		double i;
		bool found;

		numberTable = nGetDigitCharacterTable();
		found = false;

		for(i = 0d; i < basex; i = i + 1d){
			if(numberTable[(int)(i)] == c){
				found = true;
			}
		}

		return found;
	}


	public static double [] nStringToNumberArray(char [] str){
		NumberArrayReference numberArrayReference;
		StringReference stringReference;
		double [] numbers;

		numberArrayReference = new NumberArrayReference();
		stringReference = new StringReference();

		nStringToNumberArrayWithCheck(str, numberArrayReference, stringReference);

		numbers = numberArrayReference.numberArray;

		delete(numberArrayReference);
		delete(stringReference);

		return numbers;
	}


	public static bool nStringToNumberArrayWithCheck(char [] str, NumberArrayReference numberArrayReference, StringReference errorMessage){
		StringReference [] numberStrings;
		double [] numbers;
		double i;
		char [] numberString, trimmedNumberString;
		bool success;
		NumberReference numberReference;

		numberStrings = SplitByString(str, ",".ToCharArray());

		numbers = new double [(int)(numberStrings.Length)];
		success = true;
		numberReference = new NumberReference();

		for(i = 0d; i < numberStrings.Length; i = i + 1d){
			numberString = numberStrings[(int)(i)].stringx;
			trimmedNumberString = Trim(numberString);
			success = nCreateNumberFromDecimalStringWithCheck(trimmedNumberString, numberReference, errorMessage);
			numbers[(int)(i)] = numberReference.numberValue;

			FreeStringReference(numberStrings[(int)(i)]);
			delete(trimmedNumberString);
		}

		delete(numberStrings);
		delete(numberReference);

		numberArrayReference.numberArray = numbers;

		return success;
	}


	public static void AssertFalse(bool b, NumberReference failures){
		if(b){
			failures.numberValue = failures.numberValue + 1d;
		}
	}


	public static void AssertTrue(bool b, NumberReference failures){
		if(!b){
			failures.numberValue = failures.numberValue + 1d;
		}
	}


	public static void AssertEquals(double a, double b, NumberReference failures){
		if(a != b){
			failures.numberValue = failures.numberValue + 1d;
		}
	}


	public static void AssertBooleansEqual(bool a, bool b, NumberReference failures){
		if(a != b){
			failures.numberValue = failures.numberValue + 1d;
		}
	}


	public static void AssertCharactersEqual(char a, char b, NumberReference failures){
		if(a != b){
			failures.numberValue = failures.numberValue + 1d;
		}
	}


	public static void AssertStringEquals(char [] a, char [] b, NumberReference failures){
		if(!StringsEqual(a, b)){
			failures.numberValue = failures.numberValue + 1d;
		}
	}


	public static void AssertNumberArraysEqual(double [] a, double [] b, NumberReference failures){
		double i;

		if(a.Length == b.Length){
			for(i = 0d; i < a.Length; i = i + 1d){
				AssertEquals(a[(int)(i)], b[(int)(i)], failures);
			}
		}else{
			failures.numberValue = failures.numberValue + 1d;
		}
	}


	public static void AssertBooleanArraysEqual(bool [] a, bool [] b, NumberReference failures){
		double i;

		if(a.Length == b.Length){
			for(i = 0d; i < a.Length; i = i + 1d){
				AssertBooleansEqual(a[(int)(i)], b[(int)(i)], failures);
			}
		}else{
			failures.numberValue = failures.numberValue + 1d;
		}
	}


	public static void AssertStringArraysEqual(StringReference [] a, StringReference [] b, NumberReference failures){
		double i;

		if(a.Length == b.Length){
			for(i = 0d; i < a.Length; i = i + 1d){
				AssertStringEquals(a[(int)(i)].stringx, b[(int)(i)].stringx, failures);
			}
		}else{
			failures.numberValue = failures.numberValue + 1d;
		}
	}


	public static double [] AddNumber(double [] list, double a){
		double [] newlist;
		double i;

		newlist = new double [(int)(list.Length + 1d)];
		for(i = 0d; i < list.Length; i = i + 1d){
			newlist[(int)(i)] = list[(int)(i)];
		}
		newlist[(int)(list.Length)] = a;
		
		delete(list);
		
		return newlist;
	}


	public static void AddNumberRef(NumberArrayReference list, double i){
		list.numberArray = AddNumber(list.numberArray, i);
	}


	public static double [] RemoveNumber(double [] list, double n){
		double [] newlist;
		double i;

		newlist = new double [(int)(list.Length - 1d)];

		if(n >= 0d && n < list.Length){
			for(i = 0d; i < list.Length; i = i + 1d){
				if(i < n){
					newlist[(int)(i)] = list[(int)(i)];
				}
				if(i > n){
					newlist[(int)(i - 1d)] = list[(int)(i)];
				}
			}

			delete(list);
		}else{
			delete(newlist);
		}
		
		return newlist;
	}


	public static double GetNumberRef(NumberArrayReference list, double i){
		return list.numberArray[(int)(i)];
	}


	public static void RemoveNumberRef(NumberArrayReference list, double i){
		list.numberArray = RemoveNumber(list.numberArray, i);
	}


	public static StringReference [] AddString(StringReference [] list, StringReference a){
		StringReference [] newlist;
		double i;

		newlist = new StringReference [(int)(list.Length + 1d)];

		for(i = 0d; i < list.Length; i = i + 1d){
			newlist[(int)(i)] = list[(int)(i)];
		}
		newlist[(int)(list.Length)] = a;
		
		delete(list);
		
		return newlist;
	}


	public static void AddStringRef(StringArrayReference list, StringReference i){
		list.stringArray = AddString(list.stringArray, i);
	}


	public static StringReference [] RemoveString(StringReference [] list, double n){
		StringReference [] newlist;
		double i;

		newlist = new StringReference [(int)(list.Length - 1d)];

		if(n >= 0d && n < list.Length){
			for(i = 0d; i < list.Length; i = i + 1d){
				if(i < n){
					newlist[(int)(i)] = list[(int)(i)];
				}
				if(i > n){
					newlist[(int)(i - 1d)] = list[(int)(i)];
				}
			}

			delete(list);
		}else{
			delete(newlist);
		}
		
		return newlist;
	}


	public static StringReference GetStringRef(StringArrayReference list, double i){
		return list.stringArray[(int)(i)];
	}


	public static void RemoveStringRef(StringArrayReference list, double i){
		list.stringArray = RemoveString(list.stringArray, i);
	}


	public static bool [] AddBoolean(bool [] list, bool a){
		bool [] newlist;
		double i;

		newlist = new bool [(int)(list.Length + 1d)];
		for(i = 0d; i < list.Length; i = i + 1d){
			newlist[(int)(i)] = list[(int)(i)];
		}
		newlist[(int)(list.Length)] = a;
		
		delete(list);
		
		return newlist;
	}


	public static void AddBooleanRef(BooleanArrayReference list, bool i){
		list.booleanArray = AddBoolean(list.booleanArray, i);
	}


	public static bool [] RemoveBoolean(bool [] list, double n){
		bool [] newlist;
		double i;

		newlist = new bool [(int)(list.Length - 1d)];

		if(n >= 0d && n < list.Length){
			for(i = 0d; i < list.Length; i = i + 1d){
				if(i < n){
					newlist[(int)(i)] = list[(int)(i)];
				}
				if(i > n){
					newlist[(int)(i - 1d)] = list[(int)(i)];
				}
			}

			delete(list);
		}else{
			delete(newlist);
		}
		
		return newlist;
	}


	public static bool GetBooleanRef(BooleanArrayReference list, double i){
		return list.booleanArray[(int)(i)];
	}


	public static void RemoveDecimalRef(BooleanArrayReference list, double i){
		list.booleanArray = RemoveBoolean(list.booleanArray, i);
	}


	public static LinkedListStrings CreateLinkedListString(){
		LinkedListStrings ll;

		ll = new LinkedListStrings();
		ll.first = new LinkedListNodeStrings();
		ll.last = ll.first;
		ll.last.end = true;

		return ll;
	}


	public static void LinkedListAddString(LinkedListStrings ll, char [] value){
		ll.last.end = false;
		ll.last.value = value;
		ll.last.next = new LinkedListNodeStrings();
		ll.last.next.end = true;
		ll.last = ll.last.next;
	}


	public static StringReference [] LinkedListStringsToArray(LinkedListStrings ll){
		StringReference [] array;
		double length, i;
		LinkedListNodeStrings node;

		node = ll.first;

		length = LinkedListStringsLength(ll);

		array = new StringReference [(int)(length)];

		for(i = 0d; i < length; i = i + 1d){
			array[(int)(i)] = new StringReference();
			array[(int)(i)].stringx = node.value;
			node = node.next;
		}

		return array;
	}


	public static double LinkedListStringsLength(LinkedListStrings ll){
		double l;
		LinkedListNodeStrings node;

		l = 0d;
		node = ll.first;
		for(; !node.end; ){
			node = node.next;
			l = l + 1d;
		}

		return l;
	}


	public static void FreeLinkedListString(LinkedListStrings ll){
		LinkedListNodeStrings node, prev;

		node = ll.first;

		for(; !node.end; ){
			prev = node;
			node = node.next;
			delete(prev);
		}

		delete(node);
	}


	public static LinkedListNumbers CreateLinkedListNumbers(){
		LinkedListNumbers ll;

		ll = new LinkedListNumbers();
		ll.first = new LinkedListNodeNumbers();
		ll.last = ll.first;
		ll.last.end = true;

		return ll;
	}


	public static LinkedListNumbers [] CreateLinkedListNumbersArray(double length){
		LinkedListNumbers [] lls;
		double i;

		lls = new LinkedListNumbers [(int)(length)];
		for(i = 0d; i < lls.Length; i = i + 1d){
			lls[(int)(i)] = CreateLinkedListNumbers();
		}

		return lls;
	}


	public static void LinkedListAddNumber(LinkedListNumbers ll, double value){
		ll.last.end = false;
		ll.last.value = value;
		ll.last.next = new LinkedListNodeNumbers();
		ll.last.next.end = true;
		ll.last = ll.last.next;
	}


	public static double LinkedListNumbersLength(LinkedListNumbers ll){
		double l;
		LinkedListNodeNumbers node;

		l = 0d;
		node = ll.first;
		for(; !node.end; ){
			node = node.next;
			l = l + 1d;
		}

		return l;
	}


	public static double LinkedListNumbersIndex(LinkedListNumbers ll, double index){
		double i;
		LinkedListNodeNumbers node;

		node = ll.first;
		for(i = 0d; i < index; i = i + 1d){
			node = node.next;
		}

		return node.value;
	}


	public static void LinkedListInsertNumber(LinkedListNumbers ll, double index, double value){
		double i;
		LinkedListNodeNumbers node, tmp;

		if(index == 0d){
			tmp = ll.first;
			ll.first = new LinkedListNodeNumbers();
			ll.first.next = tmp;
			ll.first.value = value;
			ll.first.end = false;
		}else{
			node = ll.first;
			for(i = 0d; i < index - 1d; i = i + 1d){
				node = node.next;
			}

			tmp = node.next;
			node.next = new LinkedListNodeNumbers();
			node.next.next = tmp;
			node.next.value = value;
			node.next.end = false;
		}
	}


	public static void LinkedListSet(LinkedListNumbers ll, double index, double value){
		double i;
		LinkedListNodeNumbers node;

		node = ll.first;
		for(i = 0d; i < index; i = i + 1d){
			node = node.next;
		}

		node.next.value = value;
	}


	public static void LinkedListRemoveNumber(LinkedListNumbers ll, double index){
		double i;
		LinkedListNodeNumbers node, prev;

		node = ll.first;
		prev = ll.first;

		for(i = 0d; i < index; i = i + 1d){
			prev = node;
			node = node.next;
		}

		if(index == 0d){
			ll.first = prev.next;
		}
		if(!prev.next.end){
			prev.next = prev.next.next;
		}
	}


	public static void FreeLinkedListNumbers(LinkedListNumbers ll){
		LinkedListNodeNumbers node, prev;

		node = ll.first;

		for(; !node.end; ){
			prev = node;
			node = node.next;
			delete(prev);
		}

		delete(node);
	}


	public static void FreeLinkedListNumbersArray(LinkedListNumbers [] lls){
		double i;

		for(i = 0d; i < lls.Length; i = i + 1d){
			FreeLinkedListNumbers(lls[(int)(i)]);
		}
		delete(lls);
	}


	public static double [] LinkedListNumbersToArray(LinkedListNumbers ll){
		double [] array;
		double length, i;
		LinkedListNodeNumbers node;

		node = ll.first;

		length = LinkedListNumbersLength(ll);

		array = new double [(int)(length)];

		for(i = 0d; i < length; i = i + 1d){
			array[(int)(i)] = node.value;
			node = node.next;
		}

		return array;
	}


	public static LinkedListNumbers ArrayToLinkedListNumbers(double [] array){
		LinkedListNumbers ll;
		double i;

		ll = CreateLinkedListNumbers();

		for(i = 0d; i < array.Length; i = i + 1d){
			LinkedListAddNumber(ll, array[(int)(i)]);
		}

		return ll;
	}


	public static bool LinkedListNumbersEqual(LinkedListNumbers a, LinkedListNumbers b){
		bool equal, done;
		LinkedListNodeNumbers an, bn;

		an = a.first;
		bn = b.first;

		equal = true;
		done = false;
		for(; equal && !done; ){
			if(an.end == bn.end){
				if(an.end){
					done = true;
				}else if(an.value == bn.value){
					an = an.next;
					bn = bn.next;
				}else{
					equal = false;
				}
			}else{
				equal = false;
			}
		}

		return equal;
	}


	public static LinkedListCharacters CreateLinkedListCharacter(){
		LinkedListCharacters ll;

		ll = new LinkedListCharacters();
		ll.first = new LinkedListNodeCharacters();
		ll.last = ll.first;
		ll.last.end = true;

		return ll;
	}


	public static void LinkedListAddCharacter(LinkedListCharacters ll, char value){
		ll.last.end = false;
		ll.last.value = value;
		ll.last.next = new LinkedListNodeCharacters();
		ll.last.next.end = true;
		ll.last = ll.last.next;
	}


	public static char [] LinkedListCharactersToArray(LinkedListCharacters ll){
		char [] array;
		double length, i;
		LinkedListNodeCharacters node;

		node = ll.first;

		length = LinkedListCharactersLength(ll);

		array = new char [(int)(length)];

		for(i = 0d; i < length; i = i + 1d){
			array[(int)(i)] = node.value;
			node = node.next;
		}

		return array;
	}


	public static double LinkedListCharactersLength(LinkedListCharacters ll){
		double l;
		LinkedListNodeCharacters node;

		l = 0d;
		node = ll.first;
		for(; !node.end; ){
			node = node.next;
			l = l + 1d;
		}

		return l;
	}


	public static void FreeLinkedListCharacter(LinkedListCharacters ll){
		LinkedListNodeCharacters node, prev;

		node = ll.first;

		for(; !node.end; ){
			prev = node;
			node = node.next;
			delete(prev);
		}

		delete(node);
	}


	public static DynamicArrayNumbers CreateDynamicArrayNumbers(){
		DynamicArrayNumbers da;

		da = new DynamicArrayNumbers();
		da.array = new double [10];
		da.length = 0d;

		return da;
	}


	public static DynamicArrayNumbers CreateDynamicArrayNumbersWithInitialCapacity(double capacity){
		DynamicArrayNumbers da;

		da = new DynamicArrayNumbers();
		da.array = new double [(int)(capacity)];
		da.length = 0d;

		return da;
	}


	public static void DynamicArrayAddNumber(DynamicArrayNumbers da, double value){
		if(da.length == da.array.Length){
			DynamicArrayNumbersIncreaseSize(da);
		}

		da.array[(int)(da.length)] = value;
		da.length = da.length + 1d;
	}


	public static void DynamicArrayNumbersIncreaseSize(DynamicArrayNumbers da){
		double newLength, i;
		double [] newArray;

		newLength = (double)Round(da.array.Length*3d/2d);
		newArray = new double [(int)(newLength)];

		for(i = 0d; i < da.array.Length; i = i + 1d){
			newArray[(int)(i)] = da.array[(int)(i)];
		}

		delete(da.array);

		da.array = newArray;
	}


	public static bool DynamicArrayNumbersDecreaseSizeNecessary(DynamicArrayNumbers da){
		bool needsDecrease;

		needsDecrease = false;

		if(da.length > 10d){
			needsDecrease = da.length <= (double)Round(da.array.Length*2d/3d);
		}

		return needsDecrease;
	}


	public static void DynamicArrayNumbersDecreaseSize(DynamicArrayNumbers da){
		double newLength, i;
		double [] newArray;

		newLength = (double)Round(da.array.Length*2d/3d);
		newArray = new double [(int)(newLength)];

		for(i = 0d; i < da.array.Length; i = i + 1d){
			newArray[(int)(i)] = da.array[(int)(i)];
		}

		delete(da.array);

		da.array = newArray;
	}


	public static double DynamicArrayNumbersIndex(DynamicArrayNumbers da, double index){
		return da.array[(int)(index)];
	}


	public static double DynamicArrayNumbersLength(DynamicArrayNumbers da){
		return da.length;
	}


	public static void DynamicArrayInsertNumber(DynamicArrayNumbers da, double index, double value){
		double i;

		if(da.length == da.array.Length){
			DynamicArrayNumbersIncreaseSize(da);
		}

		for(i = da.length; i > index; i = i - 1d){
			da.array[(int)(i)] = da.array[(int)(i - 1d)];
		}

		da.array[(int)(index)] = value;

		da.length = da.length + 1d;
	}


	public static void DynamicArraySet(DynamicArrayNumbers da, double index, double value){
		da.array[(int)(index)] = value;
	}


	public static void DynamicArrayRemoveNumber(DynamicArrayNumbers da, double index){
		double i;

		for(i = index; i < da.length - 1d; i = i + 1d){
			da.array[(int)(i)] = da.array[(int)(i + 1d)];
		}

		da.length = da.length - 1d;

		if(DynamicArrayNumbersDecreaseSizeNecessary(da)){
			DynamicArrayNumbersDecreaseSize(da);
		}
	}


	public static void FreeDynamicArrayNumbers(DynamicArrayNumbers da){
		delete(da.array);
		delete(da);
	}


	public static double [] DynamicArrayNumbersToArray(DynamicArrayNumbers da){
		double [] array;
		double i;

		array = new double [(int)(da.length)];

		for(i = 0d; i < da.length; i = i + 1d){
			array[(int)(i)] = da.array[(int)(i)];
		}

		return array;
	}


	public static DynamicArrayNumbers ArrayToDynamicArrayNumbersWithOptimalSize(double [] array){
		DynamicArrayNumbers da;
		double i;
		double c, n, newCapacity;

		/*
         c = 10*(3/2)^n
         log(c) = log(10*(3/2)^n)
         log(c) = log(10) + log((3/2)^n)
         log(c) = 1 + log((3/2)^n)
         log(c) - 1 = log((3/2)^n)
         log(c) - 1 = n*log(3/2)
         n = (log(c) - 1)/log(3/2)
        */
		c = array.Length;
		n = (Log(c) - 1d)/Log(3d/2d);
		newCapacity = Floor(n) + 1d;

		da = CreateDynamicArrayNumbersWithInitialCapacity(newCapacity);

		for(i = 0d; i < array.Length; i = i + 1d){
			da.array[(int)(i)] = array[(int)(i)];
		}

		return da;
	}


	public static DynamicArrayNumbers ArrayToDynamicArrayNumbers(double [] array){
		DynamicArrayNumbers da;

		da = new DynamicArrayNumbers();
		da.array = CopyNumberArray(array);
		da.length = array.Length;

		return da;
	}


	public static bool DynamicArrayNumbersEqual(DynamicArrayNumbers a, DynamicArrayNumbers b){
		bool equal;
		double i;

		equal = true;
		if(a.length == b.length){
			for(i = 0d; i < a.length && equal; i = i + 1d){
				if(a.array[(int)(i)] != b.array[(int)(i)]){
					equal = false;
				}
			}
		}else{
			equal = false;
		}

		return equal;
	}


	public static LinkedListNumbers DynamicArrayNumbersToLinkedList(DynamicArrayNumbers da){
		LinkedListNumbers ll;
		double i;

		ll = CreateLinkedListNumbers();

		for(i = 0d; i < da.length; i = i + 1d){
			LinkedListAddNumber(ll, da.array[(int)(i)]);
		}

		return ll;
	}


	public static DynamicArrayNumbers LinkedListToDynamicArrayNumbers(LinkedListNumbers ll){
		DynamicArrayNumbers da;
		double i;
		LinkedListNodeNumbers node;

		node = ll.first;

		da = new DynamicArrayNumbers();
		da.length = LinkedListNumbersLength(ll);

		da.array = new double [(int)(da.length)];

		for(i = 0d; i < da.length; i = i + 1d){
			da.array[(int)(i)] = node.value;
			node = node.next;
		}

		return da;
	}


	public static char [] AddCharacter(char [] list, char a){
		char [] newlist;
		double i;

		newlist = new char [(int)(list.Length + 1d)];
		for(i = 0d; i < list.Length; i = i + 1d){
			newlist[(int)(i)] = list[(int)(i)];
		}
		newlist[(int)(list.Length)] = a;
		
		delete(list);
		
		return newlist;
	}


	public static void AddCharacterRef(StringReference list, char i){
		list.stringx = AddCharacter(list.stringx, i);
	}


	public static char [] RemoveCharacter(char [] list, double n){
		char [] newlist;
		double i;

		newlist = new char [(int)(list.Length - 1d)];

		if(n >= 0d && n < list.Length){
			for(i = 0d; i < list.Length; i = i + 1d){
				if(i < n){
					newlist[(int)(i)] = list[(int)(i)];
				}
				if(i > n){
					newlist[(int)(i - 1d)] = list[(int)(i)];
				}
			}

			delete(list);
		}else{
			delete(newlist);
		}

		return newlist;
	}


	public static char GetCharacterRef(StringReference list, double i){
		return list.stringx[(int)(i)];
	}


	public static void RemoveCharacterRef(StringReference list, double i){
		list.stringx = RemoveCharacter(list.stringx, i);
	}


	public static char charToLowerCase(char character){
		char toReturn;

		toReturn = character;
		if(character == 'A'){
			toReturn = 'a';
		}else if(character == 'B'){
			toReturn = 'b';
		}else if(character == 'C'){
			toReturn = 'c';
		}else if(character == 'D'){
			toReturn = 'd';
		}else if(character == 'E'){
			toReturn = 'e';
		}else if(character == 'F'){
			toReturn = 'f';
		}else if(character == 'G'){
			toReturn = 'g';
		}else if(character == 'H'){
			toReturn = 'h';
		}else if(character == 'I'){
			toReturn = 'i';
		}else if(character == 'J'){
			toReturn = 'j';
		}else if(character == 'K'){
			toReturn = 'k';
		}else if(character == 'L'){
			toReturn = 'l';
		}else if(character == 'M'){
			toReturn = 'm';
		}else if(character == 'N'){
			toReturn = 'n';
		}else if(character == 'O'){
			toReturn = 'o';
		}else if(character == 'P'){
			toReturn = 'p';
		}else if(character == 'Q'){
			toReturn = 'q';
		}else if(character == 'R'){
			toReturn = 'r';
		}else if(character == 'S'){
			toReturn = 's';
		}else if(character == 'T'){
			toReturn = 't';
		}else if(character == 'U'){
			toReturn = 'u';
		}else if(character == 'V'){
			toReturn = 'v';
		}else if(character == 'W'){
			toReturn = 'w';
		}else if(character == 'X'){
			toReturn = 'x';
		}else if(character == 'Y'){
			toReturn = 'y';
		}else if(character == 'Z'){
			toReturn = 'z';
		}

		return toReturn;
	}


	public static char charToUpperCase(char character){
		char toReturn;

		toReturn = character;
		if(character == 'a'){
			toReturn = 'A';
		}else if(character == 'b'){
			toReturn = 'B';
		}else if(character == 'c'){
			toReturn = 'C';
		}else if(character == 'd'){
			toReturn = 'D';
		}else if(character == 'e'){
			toReturn = 'E';
		}else if(character == 'f'){
			toReturn = 'F';
		}else if(character == 'g'){
			toReturn = 'G';
		}else if(character == 'h'){
			toReturn = 'H';
		}else if(character == 'i'){
			toReturn = 'I';
		}else if(character == 'j'){
			toReturn = 'J';
		}else if(character == 'k'){
			toReturn = 'K';
		}else if(character == 'l'){
			toReturn = 'L';
		}else if(character == 'm'){
			toReturn = 'M';
		}else if(character == 'n'){
			toReturn = 'N';
		}else if(character == 'o'){
			toReturn = 'O';
		}else if(character == 'p'){
			toReturn = 'P';
		}else if(character == 'q'){
			toReturn = 'Q';
		}else if(character == 'r'){
			toReturn = 'R';
		}else if(character == 's'){
			toReturn = 'S';
		}else if(character == 't'){
			toReturn = 'T';
		}else if(character == 'u'){
			toReturn = 'U';
		}else if(character == 'v'){
			toReturn = 'V';
		}else if(character == 'w'){
			toReturn = 'W';
		}else if(character == 'x'){
			toReturn = 'X';
		}else if(character == 'y'){
			toReturn = 'Y';
		}else if(character == 'z'){
			toReturn = 'Z';
		}

		return toReturn;
	}


	public static bool charIsUpperCase(char character){
		bool isUpper;

		isUpper = false;
		if(character == 'A'){
			isUpper = true;
		}else if(character == 'B'){
			isUpper = true;
		}else if(character == 'C'){
			isUpper = true;
		}else if(character == 'D'){
			isUpper = true;
		}else if(character == 'E'){
			isUpper = true;
		}else if(character == 'F'){
			isUpper = true;
		}else if(character == 'G'){
			isUpper = true;
		}else if(character == 'H'){
			isUpper = true;
		}else if(character == 'I'){
			isUpper = true;
		}else if(character == 'J'){
			isUpper = true;
		}else if(character == 'K'){
			isUpper = true;
		}else if(character == 'L'){
			isUpper = true;
		}else if(character == 'M'){
			isUpper = true;
		}else if(character == 'N'){
			isUpper = true;
		}else if(character == 'O'){
			isUpper = true;
		}else if(character == 'P'){
			isUpper = true;
		}else if(character == 'Q'){
			isUpper = true;
		}else if(character == 'R'){
			isUpper = true;
		}else if(character == 'S'){
			isUpper = true;
		}else if(character == 'T'){
			isUpper = true;
		}else if(character == 'U'){
			isUpper = true;
		}else if(character == 'V'){
			isUpper = true;
		}else if(character == 'W'){
			isUpper = true;
		}else if(character == 'X'){
			isUpper = true;
		}else if(character == 'Y'){
			isUpper = true;
		}else if(character == 'Z'){
			isUpper = true;
		}

		return isUpper;
	}


	public static bool charIsLowerCase(char character){
		bool isLower;

		isLower = false;
		if(character == 'a'){
			isLower = true;
		}else if(character == 'b'){
			isLower = true;
		}else if(character == 'c'){
			isLower = true;
		}else if(character == 'd'){
			isLower = true;
		}else if(character == 'e'){
			isLower = true;
		}else if(character == 'f'){
			isLower = true;
		}else if(character == 'g'){
			isLower = true;
		}else if(character == 'h'){
			isLower = true;
		}else if(character == 'i'){
			isLower = true;
		}else if(character == 'j'){
			isLower = true;
		}else if(character == 'k'){
			isLower = true;
		}else if(character == 'l'){
			isLower = true;
		}else if(character == 'm'){
			isLower = true;
		}else if(character == 'n'){
			isLower = true;
		}else if(character == 'o'){
			isLower = true;
		}else if(character == 'p'){
			isLower = true;
		}else if(character == 'q'){
			isLower = true;
		}else if(character == 'r'){
			isLower = true;
		}else if(character == 's'){
			isLower = true;
		}else if(character == 't'){
			isLower = true;
		}else if(character == 'u'){
			isLower = true;
		}else if(character == 'v'){
			isLower = true;
		}else if(character == 'w'){
			isLower = true;
		}else if(character == 'x'){
			isLower = true;
		}else if(character == 'y'){
			isLower = true;
		}else if(character == 'z'){
			isLower = true;
		}

		return isLower;
	}


	public static bool charIsLetter(char character){
		return charIsUpperCase(character) || charIsLowerCase(character);
	}


	public static bool charIsNumber(char character){
		bool isNumberx;

		isNumberx = false;
		if(character == '0'){
			isNumberx = true;
		}else if(character == '1'){
			isNumberx = true;
		}else if(character == '2'){
			isNumberx = true;
		}else if(character == '3'){
			isNumberx = true;
		}else if(character == '4'){
			isNumberx = true;
		}else if(character == '5'){
			isNumberx = true;
		}else if(character == '6'){
			isNumberx = true;
		}else if(character == '7'){
			isNumberx = true;
		}else if(character == '8'){
			isNumberx = true;
		}else if(character == '9'){
			isNumberx = true;
		}

		return isNumberx;
	}


	public static bool charIsWhiteSpace(char character){
		bool isWhiteSpacex;

		isWhiteSpacex = false;
		if(character == ' '){
			isWhiteSpacex = true;
		}else if(character == '\t'){
			isWhiteSpacex = true;
		}else if(character == '\n'){
			isWhiteSpacex = true;
		}else if(character == '\r'){
			isWhiteSpacex = true;
		}

		return isWhiteSpacex;
	}


	public static bool charIsSymbol(char character){
		bool isSymbolx;

		isSymbolx = false;
		if(character == '!'){
			isSymbolx = true;
		}else if(character == '\"'){
			isSymbolx = true;
		}else if(character == '#'){
			isSymbolx = true;
		}else if(character == '$'){
			isSymbolx = true;
		}else if(character == '%'){
			isSymbolx = true;
		}else if(character == '&'){
			isSymbolx = true;
		}else if(character == '\''){
			isSymbolx = true;
		}else if(character == '('){
			isSymbolx = true;
		}else if(character == ')'){
			isSymbolx = true;
		}else if(character == '*'){
			isSymbolx = true;
		}else if(character == '+'){
			isSymbolx = true;
		}else if(character == ','){
			isSymbolx = true;
		}else if(character == '-'){
			isSymbolx = true;
		}else if(character == '.'){
			isSymbolx = true;
		}else if(character == '/'){
			isSymbolx = true;
		}else if(character == ':'){
			isSymbolx = true;
		}else if(character == ';'){
			isSymbolx = true;
		}else if(character == '<'){
			isSymbolx = true;
		}else if(character == '='){
			isSymbolx = true;
		}else if(character == '>'){
			isSymbolx = true;
		}else if(character == '?'){
			isSymbolx = true;
		}else if(character == '@'){
			isSymbolx = true;
		}else if(character == '['){
			isSymbolx = true;
		}else if(character == '\\'){
			isSymbolx = true;
		}else if(character == ']'){
			isSymbolx = true;
		}else if(character == '^'){
			isSymbolx = true;
		}else if(character == '_'){
			isSymbolx = true;
		}else if(character == '`'){
			isSymbolx = true;
		}else if(character == '{'){
			isSymbolx = true;
		}else if(character == '|'){
			isSymbolx = true;
		}else if(character == '}'){
			isSymbolx = true;
		}else if(character == '~'){
			isSymbolx = true;
		}

		return isSymbolx;
	}


	public static bool charCharacterIsBefore(char a, char b){
		double ad, bd;

		ad = a;
		bd = b;

		return ad < bd;
	}


	public static double [] StringToNumberArray(char [] stringx){
		double i;
		double [] array;

		array = new double [(int)(stringx.Length)];

		for(i = 0d; i < stringx.Length; i = i + 1d){
			array[(int)(i)] = stringx[(int)(i)];
		}
		return array;
	}


	public static char [] NumberArrayToString(double [] array){
		double i;
		char [] stringx;

		stringx = new char [(int)(array.Length)];

		for(i = 0d; i < array.Length; i = i + 1d){
			stringx[(int)(i)] = (char)(array[(int)(i)]);
		}
		return stringx;
	}


	public static bool NumberArraysEqual(double [] a, double [] b){
		bool equal;
		double i;

		equal = true;
		if(a.Length == b.Length){
			for(i = 0d; i < a.Length && equal; i = i + 1d){
				if(a[(int)(i)] != b[(int)(i)]){
					equal = false;
				}
			}
		}else{
			equal = false;
		}

		return equal;
	}


	public static bool BooleanArraysEqual(bool [] a, bool [] b){
		bool equal;
		double i;

		equal = true;
		if(a.Length == b.Length){
			for(i = 0d; i < a.Length && equal; i = i + 1d){
				if(a[(int)(i)] != b[(int)(i)]){
					equal = false;
				}
			}
		}else{
			equal = false;
		}

		return equal;
	}


	public static bool StringsEqual(char [] a, char [] b){
		bool equal;
		double i;

		equal = true;
		if(a.Length == b.Length){
			for(i = 0d; i < a.Length && equal; i = i + 1d){
				if(a[(int)(i)] != b[(int)(i)]){
					equal = false;
				}
			}
		}else{
			equal = false;
		}

		return equal;
	}


	public static void FillNumberArray(double [] a, double value){
		double i;

		for(i = 0d; i < a.Length; i = i + 1d){
			a[(int)(i)] = value;
		}
	}


	public static void FillString(char [] a, char value){
		double i;

		for(i = 0d; i < a.Length; i = i + 1d){
			a[(int)(i)] = value;
		}
	}


	public static void FillBooleanArray(bool [] a, bool value){
		double i;

		for(i = 0d; i < a.Length; i = i + 1d){
			a[(int)(i)] = value;
		}
	}


	public static bool FillNumberArrayRange(double [] a, double value, double from, double to){
		double i, length;
		bool success;

		if(from >= 0d && from <= a.Length && to >= 0d && to <= a.Length && from <= to){
			length = to - from;
			for(i = 0d; i < length; i = i + 1d){
				a[(int)(from + i)] = value;
			}

			success = true;
		}else{
			success = false;
		}

		return success;
	}


	public static bool FillBooleanArrayRange(bool [] a, bool value, double from, double to){
		double i, length;
		bool success;

		if(from >= 0d && from <= a.Length && to >= 0d && to <= a.Length && from <= to){
			length = to - from;
			for(i = 0d; i < length; i = i + 1d){
				a[(int)(from + i)] = value;
			}

			success = true;
		}else{
			success = false;
		}

		return success;
	}


	public static bool FillStringRange(char [] a, char value, double from, double to){
		double i, length;
		bool success;

		if(from >= 0d && from <= a.Length && to >= 0d && to <= a.Length && from <= to){
			length = to - from;
			for(i = 0d; i < length; i = i + 1d){
				a[(int)(from + i)] = value;
			}

			success = true;
		}else{
			success = false;
		}

		return success;
	}


	public static double [] CopyNumberArray(double [] a){
		double i;
		double [] n;

		n = new double [(int)(a.Length)];

		for(i = 0d; i < a.Length; i = i + 1d){
			n[(int)(i)] = a[(int)(i)];
		}

		return n;
	}


	public static bool [] CopyBooleanArray(bool [] a){
		double i;
		bool [] n;

		n = new bool [(int)(a.Length)];

		for(i = 0d; i < a.Length; i = i + 1d){
			n[(int)(i)] = a[(int)(i)];
		}

		return n;
	}


	public static char [] CopyString(char [] a){
		double i;
		char [] n;

		n = new char [(int)(a.Length)];

		for(i = 0d; i < a.Length; i = i + 1d){
			n[(int)(i)] = a[(int)(i)];
		}

		return n;
	}


	public static bool CopyNumberArrayRange(double [] a, double from, double to, NumberArrayReference copyReference){
		double i, length;
		double [] n;
		bool success;

		if(from >= 0d && from <= a.Length && to >= 0d && to <= a.Length && from <= to){
			length = to - from;
			n = new double [(int)(length)];

			for(i = 0d; i < length; i = i + 1d){
				n[(int)(i)] = a[(int)(from + i)];
			}

			copyReference.numberArray = n;
			success = true;
		}else{
			success = false;
		}

		return success;
	}


	public static bool CopyBooleanArrayRange(bool [] a, double from, double to, BooleanArrayReference copyReference){
		double i, length;
		bool [] n;
		bool success;

		if(from >= 0d && from <= a.Length && to >= 0d && to <= a.Length && from <= to){
			length = to - from;
			n = new bool [(int)(length)];

			for(i = 0d; i < length; i = i + 1d){
				n[(int)(i)] = a[(int)(from + i)];
			}

			copyReference.booleanArray = n;
			success = true;
		}else{
			success = false;
		}

		return success;
	}


	public static bool CopyStringRange(char [] a, double from, double to, StringReference copyReference){
		double i, length;
		char [] n;
		bool success;

		if(from >= 0d && from <= a.Length && to >= 0d && to <= a.Length && from <= to){
			length = to - from;
			n = new char [(int)(length)];

			for(i = 0d; i < length; i = i + 1d){
				n[(int)(i)] = a[(int)(from + i)];
			}

			copyReference.stringx = n;
			success = true;
		}else{
			success = false;
		}

		return success;
	}


	public static bool IsLastElement(double length, double index){
		return index + 1d == length;
	}


	public static double [] CreateNumberArray(double length, double value){
		double [] array;

		array = new double [(int)(length)];
		FillNumberArray(array, value);

		return array;
	}


	public static bool [] CreateBooleanArray(double length, bool value){
		bool [] array;

		array = new bool [(int)(length)];
		FillBooleanArray(array, value);

		return array;
	}


	public static char [] CreateString(double length, char value){
		char [] array;

		array = new char [(int)(length)];
		FillString(array, value);

		return array;
	}


	public static void SwapElementsOfNumberArray(double [] A, double ai, double bi){
		double tmp;

		tmp = A[(int)(ai)];
		A[(int)(ai)] = A[(int)(bi)];
		A[(int)(bi)] = tmp;
	}


	public static void SwapElementsOfStringArray(StringArrayReference A, double ai, double bi){
		StringReference tmp;

		tmp = A.stringArray[(int)(ai)];
		A.stringArray[(int)(ai)] = A.stringArray[(int)(bi)];
		A.stringArray[(int)(bi)] = tmp;
	}


	public static void ReverseNumberArray(double [] array){
		double i;

		for(i = 0d; i < array.Length/2d; i = i + 1d){
			SwapElementsOfNumberArray(array, i, array.Length - i - 1d);
		}
	}


	public static void delete(System.Object objectx){
		// C# has garbage collection.
	}
}

}